

calendar 1979
allocate 2060:1
open data "INPUT_Labour force 1978_79 to 2012_13.xls"
data(format=xls,org=rows,noverbose) 1979:1 2013:1
SOURCE(NOECHO) "HPFILTER.SRC"


/*
Disp 'The symbols /* and */ bracketing any expression prevent RATS from operating on the code
*/


DECLARE LABEL AGE SEX
DOFOR AGE = '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
     SET(SCRATCH) %S('PR'+SEX+AGE) = %S('PR'+SEX+AGE)/100.0
     @HPFILTER(LAMBDA=100)  %S('PR'+SEX+AGE)  1979:1  2013:1  %S('HPPR'+SEX+AGE)
end dofor sex
end dofor AGE


*print 1979:1 2013:1 HPPRF1519
* ULTIMATELY ESTIMATED PROJECTIONS ARE GOING INTO A FORMAT OF %S('PPRATE'+SEX+AGE)  SO CREATE THESE NOW
DOFOR AGE = '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
       DOFOR SEX = 'M' 'F'
          SET %S('PPRATE'+SEX+AGE) = %IF(t<=2013:1,%S('PR'+SEX+AGE),0.0)
       END DOFOR SEX
END DOFOR AGE


DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
       DOFOR SEX = 'M' 'F'
         SET %S('DHPPR'+SEX+AGE) = %S('HPPR'+SEX+AGE)-%S('HPPR'+SEX+AGE)(T-1)
         SET %S('DDHPPR'+SEX+AGE) = %S('DHPPR'+SEX+AGE)-%S('DHPPR'+SEX+AGE)(T-1)
        END DOFOR SEX
END DOFOR AGE


*GRAPH Historical female to male RATES
grparm AXISlabelling 28 keylabelling 28 subheader 28
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
set %s('RAT'+AGE) = %S('PRf'+AGE)/%S('PRm'+AGE)
COMPUTE SUBHEADER = 'Ratio of females to males    '+age+'  years   '
graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
# %S('rat'+age) 1979:1 2013:1  1
END dofor AGE
SPGRAPH(DONE)

DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
       DOFOR SEX = 'M' 'F'
     		@HPFILTER(LAMBDA=100)  %S('RAT'+AGE)  1979:1  2013:1  %S('HPRAT'+AGE)
         SET %S('DHPRAT'+AGE) = %S('HPRAT'+AGE)-%S('HPRAT'+AGE)(T-1)
         SET %S('DDHPRAT'+AGE) = %S('DHPRAT'+AGE)-%S('DHPRAT'+AGE)(T-1)
        END DOFOR SEX
END DOFOR AGE

DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
	SPGRAPH(vFIELD=3)
	COMPUTE SUBHEADER = age+'  years   '
	graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   # %S('hpRAT'+age) 1981:1 2013:1  1
   # %S('RAT'+age) 1981:1 2013:1  4
	graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   # %S('dhpRAT'+age) 1981:1 2013:1  1
	graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   # %S('ddhpRAT'+age) 1981:1 2013:1  1
	SPGRAPH(DONE)
END dofor AGE

set ratf2415 = prf2024/prf1519
set ratf2920 = prf2529/prf2024
set ratf3425 = prf3034/prf2529
set ratf3930 = prf3539/prf3034
set ratf4439 = prf4044/prf3539
set ratf4940 = prf4549/prf4044
set ratf5445 = prf5054/prf4549
set ratf5950 = prf5559/prf5054
set ratf6455 = prf6064/prf5559
set ratf6960 = prf6569/prf6064
set ratf7065 = prf70/prf6569

set ratm2415 = prm2024/prm1519
set ratm2920 = prm2529/prm2024
set ratm3425 = prm3034/prm2529
set ratm3930 = prm3539/prm3034
set ratm4439 = prm4044/prm3539
set ratm4940 = prm4549/prm4044
set ratm5445 = prm5054/prm4549
set ratm5950 = prm5559/prm5054
set ratm6455 = prm6064/prm5559
set ratm6960 = prm6569/prm6064
set ratm7065 = prm70/prm6569

*GRAPH Historical PRs older over younger
grparm AXISlabelling 28 keylabelling 28 subheader 28
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '2415' '2920' '3425' '3930' '4439' '4940' '5445' '5950' '6455' '6960' '7065'
COMPUTE SUBHEADER = 'Ratio of older PRs to younger PR    '+age+'  range   '
graph(subheader=subheader,PATTERns,DATES,VTICKS=5) 2
# %S('ratm'+age) 1979:1 2013:1  1
# %S('ratf'+age) 1979:1 2013:1  2
END dofor AGE
SPGRAPH(DONE)



************************************000000000000000000000000******************************************

/*

grparm AXISlabelling 12 keylabelling 12 subheader 12

* DIFFERENCING OF PRATES
compute sex = 'M'

	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		SPGRAPH(vFIELD=3)
		COMPUTE SUBHEADER = sex+age+'  years   '

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   	# %S('hppr'+sex+age) 1981:1 2013:1  1
   	# %S('pr'+sex+age) 1981:1 2013:1  4


		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('dhppr'+sex+age) 1981:1 2013:1  1

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('ddhppr'+sex+age) 1981:1 2013:1  1
	SPGRAPH(DONE)

	END dofor AGE

compute sex = 'F'

	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		SPGRAPH(vFIELD=3)
		COMPUTE SUBHEADER = sex+age+'  years   '

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   	# %S('hppr'+sex+age) 1981:1 2013:1  1
   	# %S('pr'+sex+age) 1981:1 2013:1  4


		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('dhppr'+sex+age) 1981:1 2013:1  1

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('ddhppr'+sex+age) 1981:1 2013:1  1
	SPGRAPH(DONE)

	END dofor AGE


*GRAPH Historical Part RATES
grparm AXISlabelling 28 keylabelling 28 subheader 28
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
COMPUTE SUBHEADER = 'Males    '+age+'  years   '
graph(subheader=subheader,PATTERns,DATES,VTICKS=5) 2
# %S('prm'+age) 1984:1 2013:1  1
# %S('hpprm'+age) 1984:1 2013:1  3
END dofor AGE
SPGRAPH(DONE)

grparm AXISlabelling 28 keylabelling 28 subheader 28
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
COMPUTE SUBHEADER = 'females    '+age+'  years   '
graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
# %S('prf'+age) 1984:1 2013:1  1
# %S('hpprf'+age) 1984:1 2013:1  1
END dofor AGE
SPGRAPH(DONE)

grparm AXISlabelling 28 keylabelling 28 subheader 28
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
COMPUTE SUBHEADER = 'both sexes    '+age+'  years   '
graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 4
# %S('prm'+age) 1984:1 2013:1  1
# %S('hpprm'+age) 1984:1 2013:1  1
# %S('prf'+age) 1984:1 2013:1  3
# %S('hpprf'+age) 1984:1 2013:1  4
END dofor AGE
SPGRAPH(DONE)

*/


* prf1519 looks more like an AR1 process than a logistic. It could be included below by including in the Richards curve estimation: DOFOR age = 'F1519' 'M1519'
* but the default is to use the AR1 for females and to match the male PR to the female so they do not diverge
linreg(define=AR1,NOPRINT) prf1519
# constant prf1519{1}
uforecast(equation=ar1,noprint) forf1519_ar1 2014:1 2060:1
graph(header="Forecasts vs Actuals",key=upleft) 2
# prf1519
# forf1519_ar1
SET pprateF1519 = FORF1519_AR1
set lprf1519 = log(prf1519)
set lprm1519 = log(prm1519)
linreg(noprint) lprm1519  2003:1 2013:1
# constant lprf1519
set ppratem1519 = exp(%beta(1))*ppratef1519^(%beta(2))




declare integer k
SET TREND = T
*MALES

COMPUTE SEX = 'M'

SET %S('LIM'+SEX+'1519') = 0.51
SET %S('ST'+SEX+'1519') = 2003:1
SET %S('FLEX'+SEX+'1519') =2013:1

SET %S('LIM'+SEX+'2024') = 0.8
SET %S('ST'+SEX+'2024') = 2006:1
SET %S('FLEX'+SEX+'2024') = 2013:1

SET %S('LIM'+SEX+'2529') = %S('HPPR'+SEX+'2529')(2013:1)
SET %S('LIM'+SEX+'3034') = %S('HPPR'+SEX+'3034')(2013:1)

SET %S('LIM'+SEX+'3539') = 0.93
SET %S('ST'+SEX+'3539') = 2005:1
SET %S('FLEX'+SEX+'3539') = 2014:1

SET %S('LIM'+SEX+'4044') = %S('HPPR'+SEX+'4044')(2013:1)
SET %S('LIM'+SEX+'4549') = %S('HPPR'+SEX+'4549')(2013:1)

SET %S('LIM'+SEX+'5054') = .89
SET %S('ST'+SEX+'5054') = 1999:1
SET %S('FLEX'+SEX+'5054') = 2008:1

SET %S('LIM'+SEX+'5559') = 0.85
SET %S('ST'+SEX+'5559') = 1999:1
SET %S('FLEX'+SEX+'5559') = 2011:1

SET %S('LIM'+SEX+'6064') = 0.75
SET %S('ST'+SEX+'6064') = 1997:1
SET %S('FLEX'+SEX+'6064') = 2009:1

SET %S('LIM'+SEX+'6569') = 0.45
SET %S('ST'+SEX+'6569') = 1989:1
SET %S('FLEX'+SEX+'6569') = 2009:1

SET %S('LIM'+SEX+'70') = 0.12
SET %S('ST'+SEX+'70') = 1996:1
SET %S('FLEX'+SEX+'70') = 2013:1


* NOW ESTIMATE RICHARDS CURVES
COMPUTE SEX = 'M'
DOFOR AGE=  '2024'  '3539' '5054' '5559' '6064' '6569' '70'
   COMPUTE K = FIX(%S('ST'+SEX+AGE)(1))  ;* POINT OF THE STRUCTURAL BREAK
   SET TREND2 = TREND-K   ;* RESETS T SO THAT IT IS ZERO AT THE POINT WHERE A STRUCTURAL BREAK HAS BEEN DETECTED
   COMPUTE FLEX = %S('FLEX'+SEX+AGE)(2013:1)-K  ;* THE ESTIMATED INFLECTION POINT OF THE RICHARDS RELATIVE TO THE CORRECTED STARTING VALUE
   SET HP = %S('HPPR'+SEX+AGE)   ;* SMOOTHED (HODRICK-PRESCOTT) PARTICIPATION RATES
   COMPUTE POS = %IF(HP(2013:1)-HP(K)>0,1.0,-1.0)
   COMPUTE LIM = %S('LIM'+SEX+AGE)(2013:1);* THIS IS THE MAX OR MIN VALUE OF THE NET EXIT RATE
   COMPUTE SIGN = %IF(LIM<0,-1.0,1.0)
   * INITIAL STATES OF RICHARDS PARAMETERS FOR NLLS
   COMPUTE LAMBDA = -1.0  ;* THIS IS THE LOGISTIC
   COMPUTE PHI = -3.0 ;* THIS MEANS THAT THE INITIAL VALUE OF PHI IS S.T. THE LONG RUN IS AROUND 95% OF THE LIMIT
   COMPUTE GROW = SQRT(0.15)
  * DISP K FLEX POS LIM SIGN LAMBDA PHI GROW

   NONLIN GROW PHI LAMBDA
   FRML G = -GROW*GROW
   FRML BETA = (-1.0/LAMBDA)*EXP(-G*FLEX) ;* BASED ON THE RELATIONSHIP BETWEEN BETA AND G AT THE INFLECTION POINT OF A RICHARDS
   FRML LONG =  HP(2013:1)+(1/(1+EXP(PHI)))*(LIM-HP(2013:1))  ;* provides a boundary on the limit of the curve
   FRML ALPHA = (HP(2013:1)-LONG)/(((1+BETA*exp(-GROW*GROW*TREND2(2013:1)))^LAMBDA)-1)
   FRML CON =  LONG-ALPHA
   FRML F1 HP = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   nlls(NOPRINT,frml=f1,ITERATIONS=10000,method=SIMPLEX,cvcrit=0.0000001) HP K 2013:1
   SET %S('PPRATE'+SEX+AGE) = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   *DISP AGE'BETA= ' (-1.0/LAMBDA)*EXP(-(-GROW*GROW)*FLEX)  'PHI= ' PHI 'G= ' GROW 'LAMBDA = ' LAMBDA 'LIMIT= ' LIM

GRAPH(SUBHEADER=AGE+SEX) 3
# %S('PPRATE'+SEX+AGE) 1982:1 2060:1
# HP k 2013:1
# %S('PR'+SEX+AGE) 1982:1 2060:1

END DOFOR AGE


DOFOR AGE=  '2529' '3034'  '4044' '4549'
   SET %S('PPRATE'+SEX+AGE) 1979:1 2060:1 = %IF(t<=2013:1,%S('PR'+SEX+AGE),%S('LIM'+SEX+AGE))
	GRAPH(SUBHEADER=AGE+SEX) 2
	 # %S('PPRATE'+SEX+AGE) 1979:1 2060:1
	 # %S('HPPR'+SEX+AGE) 1979:1 2013:1
END DOFOR AGE

***********************method using Richards Curves
*FEMALES

COMPUTE SEX = 'F'

SET %S('LIM'+SEX+'1519') = 0.55
SET %S('ST'+SEX+'1519') = 2005:1
SET %S('FLEX'+SEX+'1519') =2013:1

SET %S('LIM'+SEX+'2024') = 0.75
SET %S('ST'+SEX+'2024') = 2000:1
SET %S('FLEX'+SEX+'2024') = 2013:1

SET %S('LIM'+SEX+'2529') 2014:1 2060:1 = %S('HPPR'+SEX+'2529')(2013:1)

SET %S('LIM'+SEX+'3034') = 0.8
SET %S('ST'+SEX+'3034') = 1998:1
SET %S('FLEX'+SEX+'3034') = 2006:1

SET %S('LIM'+SEX+'3539') = 0.8
SET %S('ST'+SEX+'3539') = 1998:1
SET %S('FLEX'+SEX+'3539') = 2009:1

SET %S('LIM'+SEX+'4044') = 0.8
SET %S('ST'+SEX+'4044') = 1999:1
SET %S('FLEX'+SEX+'4044') = 2007:1

SET %S('LIM'+SEX+'4549')  2014:1 2060:1 = %S('HPPR'+SEX+'4549')(2013:1)


SET %S('LIM'+SEX+'5054') = .83
SET %S('ST'+SEX+'5054') = 1981:1
SET %S('FLEX'+SEX+'5054') = 1992:1

SET %S('LIM'+SEX+'5559') = .75
SET %S('ST'+SEX+'5559') = 1981:1
SET %S('FLEX'+SEX+'5559') = 2007:1

SET %S('LIM'+SEX+'6064') = 0.6
SET %S('ST'+SEX+'6064') = 1981:1
SET %S('FLEX'+SEX+'6064') = 2008:1

SET %S('LIM'+SEX+'6569') = 0.35
SET %S('ST'+SEX+'6569') = 1986:1
SET %S('FLEX'+SEX+'6569') = 2013:1

SET %S('LIM'+SEX+'70') = 0.06
SET %S('ST'+SEX+'70') = 1992:1
SET %S('FLEX'+SEX+'70') = 2013:1


* NOW ESTIMATE RICHARDS CURVES METHOD 1 FOR FEMALES
COMPUTE SEX = 'F'
DOFOR AGE=  '2024'  '3034' '3539' '4044' '5054' '5559' '6064' '6569' '70'
   COMPUTE K = FIX(%S('ST'+SEX+AGE)(1))  ;* POINT OF THE STRUCTURAL BREAK
   SET TREND2 = TREND-K   ;* RESETS T SO THAT IT IS ZERO AT THE POINT WHERE A STRUCTURAL BREAK HAS BEEN DETECTED
   COMPUTE FLEX = %S('FLEX'+SEX+AGE)(2013:1)-K  ;* THE ESTIMATED INFLECTION POINT OF THE RICHARDS RELATIVE TO THE CORRECTED STARTING VALUE
   SET HP = %S('HPPR'+SEX+AGE)   ;* SMOOTHED (HODRICK-PRESCOTT) PARTICIPATION RATES
   COMPUTE POS = %IF(HP(2013:1)-HP(K)>0,1.0,-1.0)
   COMPUTE LIM = %S('LIM'+SEX+AGE)(2013:1);* THIS IS THE MAX OR MIN VALUE OF THE NET EXIT RATE
   COMPUTE SIGN = %IF(LIM<0,-1.0,1.0)
   * INITIAL STATES OF RICHARDS PARAMETERS FOR NLLS
   COMPUTE LAMBDA = -1.0  ;* THIS IS THE LOGISTIC
   COMPUTE PHI = -3.0 ;* THIS MEANS THAT THE INITIAL VALUE OF PHI IS S.T. THE LONG RUN IS AROUND 95% OF THE LIMIT
   COMPUTE GROW = SQRT(0.15)
  * DISP K FLEX POS LIM SIGN LAMBDA PHI GROW

   NONLIN GROW PHI LAMBDA
   FRML G = -GROW*GROW
   FRML BETA = (-1.0/LAMBDA)*EXP(-G*FLEX) ;* BASED ON THE RELATIONSHIP BETWEEN BETA AND G AT THE INFLECTION POINT OF A RICHARDS
   FRML LONG =  HP(2013:1)+(1/(1+EXP(PHI)))*(LIM-HP(2013:1))  ;* provides a boundary on the limit of the curve
   FRML ALPHA = (HP(2013:1)-LONG)/(((1+BETA*exp(-GROW*GROW*TREND2(2013:1)))^LAMBDA)-1)
   FRML CON =  LONG-ALPHA
   FRML F1 HP = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   nlls(NOPRINT,frml=f1,ITERATIONS=10000,method=SIMPLEX,cvcrit=0.0000001) HP K 2013:1
   SET %S('PPRATE'+SEX+AGE) = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   *DISP AGE'BETA= ' (-1.0/LAMBDA)*EXP(-(-GROW*GROW)*FLEX)  'PHI= ' PHI 'G= ' GROW 'LAMBDA = ' LAMBDA 'LIMIT= ' LIM

GRAPH(SUBHEADER=AGE+SEX) 3
# %S('PPRATE'+SEX+AGE) 1982:1 2060:1
# HP k 2013:1
# %S('PR'+SEX+AGE) 1982:1 2060:1

END DOFOR AGE


DOFOR AGE=  '2529' '4549'
   SET %S('PPRATE'+SEX+AGE) 1979:1 2060:1 = %IF(t<=2013:1,%S('PR'+SEX+AGE),%S('LIM'+SEX+AGE))
	GRAPH(SUBHEADER=AGE+SEX) 2
	 # %S('PPRATE'+SEX+AGE) 1979:1 2060:1
	 # %S('HPPR'+SEX+AGE) 1979:1 2013:1
END DOFOR AGE

************females using method 2 ******XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

SET FRAT2024 = RAT2024(2013:1)
SET FRAT2529 = RAT2529(2013:1)
SET FRAT4549 = RAT4549(2013:1)

SET %S('LIM3034') = 0.81
SET %S('ST3034') = 1990:1
SET %S('FLEX3034') = 2012:1

SET LIM3539 = 0.82
SET ST3539 = 1996:1
SET FLEX3539 = 2008:1

SET LIM4044 = 0.88
SET ST4044 = 1992:1
SET FLEX4044 = 2006:1

SET LIM5054 = 0.9
SET ST5054 = 1981:1
SET FLEX5054 = 1991:1

SET LIM5559 = 0.88
SET ST5559 = 1981:1
SET FLEX5559 = 2000:1

SET LIM6064 = 0.80
SET ST6064 = 1987:1
SET FLEX6064 = 2004:1

SET LIM6569 = 0.70
SET ST6569 = 1993:1
SET FLEX6569 = 2013:1

SET LIM70 = 0.50
SET ST70 = 1990:1
SET FLEX70 = 2014:1





* NOW ESTIMATE RICHARDS CURVES

DOFOR AGE=  '3034' '3539' '4044' '5054' '5559' '6064' '6569' '70'
   COMPUTE K = FIX(%S('ST'+AGE)(1))  ;* POINT OF THE STRUCTURAL BREAK
   SET TREND2 = TREND-K   ;* RESETS T SO THAT IT IS ZERO AT THE POINT WHERE A STRUCTURAL BREAK HAS BEEN DETECTED
   COMPUTE FLEX = %S('FLEX'+AGE)(2013:1)-K  ;* THE ESTIMATED INFLECTION POINT OF THE RICHARDS RELATIVE TO THE CORRECTED STARTING VALUE
   SET HP = %S('HPRAT'+AGE)   ;* SMOOTHED (HODRICK-PRESCOTT) RATIO OF PR RATES
   COMPUTE POS = %IF(HP(2013:1)-HP(K)>0,1.0,-1.0)
   COMPUTE LIM = %S('LIM'+AGE)(2013:1);* THIS IS THE MAX OR MIN VALUE OF THE NET EXIT RATE
   COMPUTE SIGN = %IF(LIM<0,-1.0,1.0)
   * INITIAL STATES OF RICHARDS PARAMETERS FOR NLLS
   COMPUTE LAMBDA = -1.0  ;* THIS IS THE LOGISTIC
   COMPUTE PHI = -3.0 ;* THIS MEANS THAT THE INITIAL VALUE OF PHI IS S.T. THE LONG RUN IS AROUND 95% OF THE LIMIT
   COMPUTE GROW = SQRT(0.15)
  * DISP K FLEX POS LIM SIGN LAMBDA PHI GROW

   NONLIN GROW PHI LAMBDA
   FRML G = -GROW*GROW
   FRML BETA = (-1.0/LAMBDA)*EXP(-G*FLEX) ;* BASED ON THE RELATIONSHIP BETWEEN BETA AND G AT THE INFLECTION POINT OF A RICHARDS
   FRML LONG =  HP(2013:1)+(1/(1+EXP(PHI)))*(LIM-HP(2013:1))  ;* provides a boundary on the limit of the curve
   FRML ALPHA = (HP(2013:1)-LONG)/(((1+BETA*exp(-GROW*GROW*TREND2(2013:1)))^LAMBDA)-1)
   FRML CON =  LONG-ALPHA
   FRML F1 HP = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   nlls(NOPRINT,frml=f1,ITERATIONS=10000,method=SIMPLEX,cvcrit=0.0000001) HP K 2013:1
   SET %S('FRAT'+AGE) = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   *DISP AGE'BETA= ' (-1.0/LAMBDA)*EXP(-(-GROW*GROW)*FLEX)  'PHI= ' PHI 'G= ' GROW 'LAMBDA = ' LAMBDA 'LIMIT= ' LIM

GRAPH(SUBHEADER=AGE+SEX) 3
# %S('FRAT'+AGE) 1982:1 2060:1
# HP k 2013:1
# %S('RAT'+AGE) 1982:1 2060:1
*DISP AGE %S('FRAT'+AGE)(2060:1)
END DOFOR AGE







*************************************************************************************************
*              THIS CODE PUTS ALL THE FORECASTS INTO A CONSISTENT NAMED SERIES                  *
*              FPR DENOTES (F) FORECAST  (PR) PARTICIPATION RATE                                *
*              YOU MUST SET A METHOD (METHOD1 WAS USED IN THE PUBLISHED REPORT)                 *
*************************************************************************************************
COMPUTE METHOD = 2  ;* method 2 is based on projecting males and using projected female to male pr ratios to derive females. Method 1 is extrapolation of both PR series
set fprm1519 = ppratem1519
set fprf1519 = ppratef1519  ;* note that as discussed above, participation rates for males (not females) is based on a female rates estimated from an AR1 process, so there is no point separating method1 and 2 for this age group

DOFOR AGE =  '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
			SET %S('FPRM'+AGE) = %IF(t<=2013:1,%s('PRM'+AGE),%s('PPRATEM'+AGE))
			SET %S('FPRF'+AGE) = %IF(METHOD==1,%IF(t<=2013:1,%s('PRF'+AGE),%s('PPRATEF'+AGE)),%IF(t<=2013:1,%s('PRF'+AGE),%s('FPRM'+AGE)*%S('FRAT'+AGE)))
END DOFOR AGE

*print out of results
disp 'results by age and sex for METHOD' method
disp '_____________________________________________________________________________________________'
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
			disp age 'Participation rate males=' %S('FPRM'+AGE)(2060:1) 'Participation rate females=' %S('FPRf'+AGE)(2060:1)
END DOFOR AGE
disp '_____________________________________________________________________________________________'



*disp PPRATEF2024(2060:1)
*disp fprF2024(2060:1)
*disp fprm2024(2060:1)



* copy FORECAST data to an output file
dedit(new) "OUTPUT_PRATES 1978_79 to 2059_60_PRJ.rat"
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
			DOFOR SEX = 'F' 'M'
					store %S('FPR'+SEX+AGE)
					SAVE
			END DOFOR SEX
END DOFOR AGE

* copy FORECAST data to an output file
open copy "OUTPUT_Labour participation rates forecasts 1978_79 to 2059_60.XLS"
copy(dates,format=xls,org=columns) 1979:1 2060:1 $
FPRf1519 FPRm1519  $
FPRf2024 FPRm2024  $
FPRf2529 FPRm2529  $
FPRf3034 FPRm3034  $
FPRf3539 FPRm3539  $
FPRf4044 FPRm4044  $
FPRf4549 FPRm4549  $
FPRf5054 FPRm5054  $
FPRf5559 FPRm5559  $
FPRf6064 FPRm6064  $
FPRf6569 FPRm6569  $
FPRf70 FPRm70



 *************************************************************************************************************************************
 *** GRAPHS

*These are the relevant graphs of
*PRATES




  SET GRID 1979:1 2060:1 = (T==2013:1)
  grparm axislabelling 30 keylabelling 30 subheader 30
  SPGRAPH(HFIELD=3,vfield=4)
  DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
    SET %S('PPRF'+AGE) = %S('FPRF'+AGE)*100.
    SET %S('PPRM'+AGE) = %S('FPRM'+AGE)*100.
    EXTREMUM(NOPRINT) %S('PPRF'+age)
    COMPUTE MINVAL = %MINIMUM*(1.1)
    COMPUTE MAXF = %MAXIMUM
    EXTREMUM(NOPRINT) %S('pPRM'+age)
    COMPUTE MAXM = %MAXIMUM
    COMPUTE MAXI = %MAX(MAXF,MAXM)
    graph(frame=half,SAMESIZE,PICTURE='*.',max=MAXI,PATTERNS,VTICKS=4,ticks,grid=grid,dates) 2
    # %S('PPRM'+AGE) 1979:1 2060:1  1
    # %S('PPRF'+AGE) 1979:1 2060:1  3
    GRTEXT(ALIGN=LEFT,ENTRY=2020:1,Y=MINVAL,SIZE=36) AGE+' years'
  END DOFOR AGE
  SPGRAPH(DONE)




*graph part rate forecasts
*FEMALE PRATES
SET GRID 1979:1 2060:1 = (T==2013:1)
DECLARE LABEL AGE
grparm axislabelling 32 keylabelling 36 subheader 36
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
COMPUTE SUBHEADER =age+' years'
graph(frame=half,subheader=subheader,PATTERNS,VTICKS=5,ticks,grid=grid) 1
# %S('PPR'+'F'+age) 1979:1 2060:1  12
END DOFOR AGE
SPGRAPH(DONE)


*MALE PRATES
DECLARE LABEL AGE
grparm axislabelling 32 keylabelling 36 subheader 36
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
COMPUTE SUBHEADER = age+' years'
graph(frame=half,subheader=subheader,PATTERNS,VTICKS=5,ticks,grid=grid) 1
# %S('PPR'+'m'+age) 1979:1 2060:1  11
END DOFOR AGE
SPGRAPH(DONE)

*MALE AND FEMALE RATES (MALE=BLACK, FEMALE=RED)
DECLARE LABEL AGE
grparm axislabelling 36 keylabelling 36 subheader 36
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
COMPUTE SUBHEADER = age+' years'
graph(frame=half,subheader=subheader,PATTERNS,VTICKS=5,ticks,grid=grid) 2
# %S('PPR'+'m'+age) 1979:1 2060:1  11
# %S('PPR'+'F'+age) 1979:1 2060:1  12
END DOFOR AGE
SPGRAPH(DONE)



DISP FPRM1519(2013:1)







