calendar 1979
allocate 2060:1
open data "INPUT_Labour force 1978_79 to 2012_13.xls"
data(format=xls,org=rows,noverbose) 1979:1 2013:1
SOURCE(NOECHO) "HPFILTER.SRC"

****************************************************************************************************************************
*                                           Program written by Ralph Lattimore June 2013                                                            *
*****************************************************************************************************************************

/*
Disp 'The symbols /* and */ bracketing any expression prevent RATS from operating on the code
*/

* smooth data using a Hodrick-Preston filter so as to remove volatlity
DECLARE LABEL AGE SEX
DOFOR AGE = '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
     SET(SCRATCH) %S('PTSH'+SEX+AGE) = %S('PT'+SEX+AGE)/(%S('PT'+SEX+AGE)+%S('FT'+SEX+AGE))
     @HPFILTER(LAMBDA=100)  %S('PTSH'+SEX+AGE)  1979:1  2013:1  %S('HPPTSH'+SEX+AGE)
end dofor sex
end dofor AGE


* INITIALLY PROJECTIONS ARE GOING INTO A FORMAT OF %S('PSH'+SEX+AGE)  SO CREATE THESE NOW
DOFOR AGE = '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
       DOFOR SEX = 'M' 'F'
          SET %S('PSH'+SEX+AGE) = %IF(t<=2013:1,%S('PTSH'+SEX+AGE),0.0)
       END DOFOR SEX
END DOFOR AGE

*Create differences in the filtered variables as these are helpful for detrmining breaks and inflexion points in the Richards function
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
       DOFOR SEX = 'M' 'F'
         SET %S('DHPPTSH'+SEX+AGE) = %S('HPPTSH'+SEX+AGE)-%S('HPPTSH'+SEX+AGE)(T-1)
         SET %S('DDHPPTSH'+SEX+AGE) = %S('DHPPTSH'+SEX+AGE)-%S('DHPPTSH'+SEX+AGE)(T-1)
        END DOFOR SEX
END DOFOR AGE

************************************000000000000000000000000******************************************



/*
grparm AXISlabelling 12 keylabelling 12 subheader 12

* Graphing DIFFERENCING OF PART TIME SHARES
compute sex = 'M'

	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		SPGRAPH(vFIELD=3)
		COMPUTE SUBHEADER = sex+age+'  years   '

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   	# %S('hpPTSH'+sex+age) 1981:1 2013:1  1
   	# %S('pTSH'+sex+age) 1981:1 2013:1  4


		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('dhpPTSH'+sex+age) 1981:1 2013:1  1

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('ddhpPTSH'+sex+age) 1981:1 2013:1  1
	SPGRAPH(DONE)

	END dofor AGE

compute sex = 'F'

	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		SPGRAPH(vFIELD=3)
		COMPUTE SUBHEADER = sex+age+'  years   '

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   	# %S('hpPTSH'+sex+age) 1981:1 2013:1  1
   	# %S('PTSH'+sex+age) 1981:1 2013:1  4


		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('dhpPTSH'+sex+age) 1981:1 2013:1  1

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('ddhpPTSH'+sex+age) 1981:1 2013:1  1
	SPGRAPH(DONE)

	END dofor AGE


*GRAPH Historical PART TIME SHARE RATES
grparm AXISlabelling 28 keylabelling 28 subheader 28
COMPUTE SEX = 'M'
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'
   COMPUTE SUBHEADER = 'Males    '+age+'  years   '
   graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   # %S('PTSH'+SEX+age) 1979:1 2013:1  1
   # %S('HPPTSH'+SEX+age) 1979:1 2013:1  1
END dofor AGE
SPGRAPH(DONE)


grparm AXISlabelling 28 keylabelling 28 subheader 28
COMPUTE SEX = 'F'
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'
   COMPUTE SUBHEADER = 'Males    '+age+'  years   '
   graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   # %S('PTSH'+SEX+age) 1979:1 2013:1  1
   # %S('HPPTSH'+SEX+age) 1979:1 2013:1  1
END dofor AGE
SPGRAPH(DONE)



grparm AXISlabelling 28 keylabelling 28 subheader 28
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
      COMPUTE SUBHEADER = 'both sexes    '+age+'  years   '
      graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 4
      # %S('PTSHM'+age) 1979:1 2013:1  1
      # %S('hpPTSHM'+age) 1979:1 2013:1  1
      # %S('PTSHF'+age) 1979:1 2013:1  3
      # %S('HPPTSHF'+age) 1979:1 2013:1  4
END dofor AGE
SPGRAPH(DONE)
*/


***********************************************************************************************************************************************
*Using the information from visual inspection of the graphs above, set start points, inflexion points and likely maximum long-runs
*Non-linear estimation will determine the other variables in the Richard's curve constrained by the above assumptions), including most importantly,
*any revised estimates of the long-run value. In some instances, it appears that a series is a random walk without drift (that is, of the form X(t(=X(t-1)+ e(t)
*The long-run in this case is simply the current value.  The assumptions are based on judgment supported by graphical information and realistic steady state asumptions.
*For example, part-time shares cannot be trending in the long-run.

declare integer k
SET TREND = T
COMPUTE SEX = 'M'
SET %S('LIM'+SEX+'1519') = 0.65
SET %S('ST'+SEX+'1519') = 1981:1
SET %S('FLEX'+SEX+'1519') =1992:1

SET %S('LIM'+SEX+'2024') = 0.35
SET %S('ST'+SEX+'2024') = 1981:1
SET %S('FLEX'+SEX+'2024') = 1994:1

SET %S('LIM'+SEX+'2529') = 0.15
SET %S('ST'+SEX+'2529') = 1981:1
SET %S('FLEX'+SEX+'2529') = 1993:1

SET %S('LIM'+SEX+'3034') = 0.10
SET %S('ST'+SEX+'3034') = 1981:1
SET %S('FLEX'+SEX+'3034') = 1993:1


SET %S('LIM'+SEX+'3539') = %S('HPPTSH'+SEX+'3539')(2013:1)

SET %S('LIM'+SEX+'4044') = 0.09
SET %S('ST'+SEX+'4044') = 1981:1
SET %S('FLEX'+SEX+'4044') = 1996:1

SET %S('LIM'+SEX+'4549') = 0.10
SET %S('ST'+SEX+'4549') = 1981:1
SET %S('FLEX'+SEX+'4549') = 1996:1


SET %S('LIM'+SEX+'5054') = .125
SET %S('ST'+SEX+'5054') = 1981:1
SET %S('FLEX'+SEX+'5054') = 2000:1


SET %S('LIM'+SEX+'5559') = %S('HPPTSH'+SEX+'5559')(2013:1)
SET %S('LIM'+SEX+'6064') = %S('HPPTSH'+SEX+'6064')(2013:1)
SET %S('LIM'+SEX+'6569') = %S('HPPTSH'+SEX+'6569')(2013:1)


SET %S('LIM'+SEX+'70') = 0.6
SET %S('ST'+SEX+'70') = 1988:1
SET %S('FLEX'+SEX+'70') = 2013:1









* NOW ESTIMATE RICHARDS CURVES
COMPUTE SEX = 'M'
DOFOR AGE=  '1519' '2024'  '2529' '3034' '4044' '4549' '5054' '70'
   COMPUTE K = FIX(%S('ST'+SEX+AGE)(1))  ;* POINT OF THE STRUCTURAL BREAK
   SET TREND2 = TREND-K   ;* RESETS T SO THAT IT IS ZERO AT THE POINT WHERE A STRUCTURAL BREAK HAS BEEN DETECTED
   COMPUTE FLEX = %S('FLEX'+SEX+AGE)(2013:1)-K  ;* THE ESTIMATED INFLECTION POINT OF THE RICHARDS RELATIVE TO THE CORRECTED STARTING VALUE
   SET HP = %S('HPPTSH'+SEX+AGE)   ;* SMOOTHED (HODRICK-PRESCOTT) PT SHARES
   COMPUTE POS = %IF(HP(2013:1)-HP(K)>0,1.0,-1.0)
   COMPUTE LIM = %S('LIM'+SEX+AGE)(2013:1);* THIS IS THE MAX OR MIN VALUE
   COMPUTE SIGN = %IF(LIM<0,-1.0,1.0)
   * INITIAL STATES OF RICHARDS PARAMETERS FOR NLLS
   COMPUTE LAMBDA = -1.0  ;* THIS IS THE LOGISTIC
   COMPUTE PHI = -3.0 ;* THIS MEANS THAT THE INITIAL VALUE OF PHI IS S.T. THE LONG RUN IS AROUND 95% OF THE LIMIT
   COMPUTE GROW = SQRT(0.15)
  * DISP K FLEX POS LIM SIGN LAMBDA PHI GROW

   NONLIN GROW PHI LAMBDA
   FRML G = -GROW*GROW
   FRML BETA = (-1.0/LAMBDA)*EXP(-G*FLEX) ;* BASED ON THE RELATIONSHIP BETWEEN BETA AND G AT THE INFLECTION POINT OF A RICHARDS
   FRML LONG =  HP(2013:1)+(1/(1+EXP(PHI)))*(LIM-HP(2013:1))  ;* provides a boundary on the limit of the curve
   FRML ALPHA = (HP(2013:1)-LONG)/(((1+BETA*exp(-GROW*GROW*TREND2(2013:1)))^LAMBDA)-1)
   FRML CON =  LONG-ALPHA
   FRML F1 HP = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   nlls(NOPRINT,frml=f1,ITERATIONS=10000,method=SIMPLEX,cvcrit=0.0000001) HP K 2013:1
   SET %S('PSH'+SEX+AGE) = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   *DISP AGE'BETA= ' (-1.0/LAMBDA)*EXP(-(-GROW*GROW)*FLEX)  'PHI= ' PHI 'G= ' GROW 'LAMBDA = ' LAMBDA 'LIMIT= ' LIM

*GRAPH(SUBHEADER=AGE+SEX) 3
*# %S('PSH'+SEX+AGE) K 2060:1
*# %S('PTSH'+SEX+AGE) 1979:1 2013:1
*# HP 1979:1 2013:1

END DOFOR AGE



DOFOR AGE=  '3539' '5559'  '6064' '6569'
   SET %S('PSH'+SEX+AGE) 1979:1 2060:1 = %IF(t<=2013:1,%S('PTSH'+SEX+AGE),%S('LIM'+SEX+AGE))
*	GRAPH(SUBHEADER=AGE+SEX) 2
*	 # %S('PSH'+SEX+AGE) 1979:1 2060:1
*	 # %S('HPPTSH'+SEX+AGE) 1979:1 2013:1
END DOFOR AGE


*************************************************************************************************************************************************************************
*FEMALES
COMPUTE SEX = 'F'
SET %S('LIM'+SEX+'1519') = %S('HPPTSH'+SEX+'1519')(2013:1)

SET %S('LIM'+SEX+'2024') = 0.55
SET %S('ST'+SEX+'2024') = 2006:1
SET %S('FLEX'+SEX+'2024') = 2013:1

SET %S('LIM'+SEX+'2529') = 0.30
SET %S('ST'+SEX+'2529') = 2007:1
SET %S('FLEX'+SEX+'2529') = 2013:1

SET %S('LIM'+SEX+'3034') = 0.36
SET %S('ST'+SEX+'3034') = 1986:1
SET %S('FLEX'+SEX+'3034') = 2007:1

SET %S('LIM'+SEX+'3539') = 0.46
SET %S('ST'+SEX+'3539') = 2004:1
SET %S('FLEX'+SEX+'3539') = 2008:1

SET %S('LIM'+SEX+'4044') = 0.50
SET %S('ST'+SEX+'4044') = 1993:1
SET %S('FLEX'+SEX+'4044') = 2002:1

SET %S('LIM'+SEX+'4549') = 0.46
SET %S('ST'+SEX+'4549') = 1997:1
SET %S('FLEX'+SEX+'4549') = 2013:1

SET %S('LIM'+SEX+'5054') = %S('HPPTSH'+SEX+'5054')(2013:1)


SET %S('LIM'+SEX+'5559') = .4
SET %S('ST'+SEX+'5559') = 1999:1
SET %S('FLEX'+SEX+'5559') = 2008:1

SET %S('LIM'+SEX+'6064') = 0.5
SET %S('ST'+SEX+'6064') = 2001:1
SET %S('FLEX'+SEX+'6064') = 2007:1

SET %S('LIM'+SEX+'6569') = 0.6
SET %S('ST'+SEX+'6569') = 2003:1
SET %S('FLEX'+SEX+'6569') = 2013:1

SET %S('LIM'+SEX+'70') = %S('HPPTSH'+SEX+'70')(2013:1)


* NOW ESTIMATE RICHARDS CURVES
DOFOR AGE=   '2024' '2529' '3034' '3539' '4044' '4549' '5559' '6064' '6569'
   COMPUTE K = FIX(%S('ST'+SEX+AGE)(1))  ;* POINT OF THE STRUCTURAL BREAK
   SET TREND2 = TREND-K   ;* RESETS T SO THAT IT IS ZERO AT THE POINT WHERE A STRUCTURAL BREAK HAS BEEN DETECTED
   COMPUTE FLEX = %S('FLEX'+SEX+AGE)(2013:1)-K  ;* THE ESTIMATED INFLECTION POINT OF THE RICHARDS RELATIVE TO THE CORRECTED STARTING VALUE
   SET HP = %S('HPPTSH'+SEX+AGE)   ;* SMOOTHED (HODRICK-PRESCOTT) SHARES
   COMPUTE POS = %IF(HP(2013:1)-HP(K)>0,1.0,-1.0)
   COMPUTE LIM = %S('LIM'+SEX+AGE)(2013:1);* THIS IS THE MAX OR MIN VALUE OF THE SHARE
   COMPUTE SIGN = %IF(LIM<0,-1.0,1.0)
   * INITIAL STATES OF RICHARDS PARAMETERS FOR NLLS
   COMPUTE LAMBDA = -1.0  ;* THIS IS THE LOGISTIC
   COMPUTE PHI = -3.0 ;* THIS MEANS THAT THE INITIAL VALUE OF PHI IS S.T. THE LONG RUN IS AROUND 95% OF THE LIMIT
   COMPUTE GROW = SQRT(0.15)
  * DISP K FLEX POS LIM SIGN LAMBDA PHI GROW

   NONLIN GROW PHI LAMBDA
   FRML G = -GROW*GROW
   FRML BETA = (-1.0/LAMBDA)*EXP(-G*FLEX) ;* BASED ON THE RELATIONSHIP BETWEEN BETA AND G AT THE INFLECTION POINT OF A RICHARDS
   FRML LONG =  HP(2013:1)+(1/(1+EXP(PHI)))*(LIM-HP(2013:1))  ;* provides a boundary on the limit of the curve
   FRML ALPHA = (HP(2013:1)-LONG)/(((1+BETA*exp(-GROW*GROW*TREND2(2013:1)))^LAMBDA)-1)
   FRML CON =  LONG-ALPHA
   FRML F1 HP = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   nlls(NOPRINT,frml=f1,ITERATIONS=10000,method=SIMPLEX,cvcrit=0.0000001) HP K 2013:1
   SET %S('PSH'+SEX+AGE) = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   *DISP AGE'BETA= ' (-1.0/LAMBDA)*EXP(-(-GROW*GROW)*FLEX)  'PHI= ' PHI 'G= ' GROW 'LAMBDA = ' LAMBDA 'LIMIT= ' LIM

*GRAPH(SUBHEADER=AGE+SEX) 2
*# %S('PSH'+SEX+AGE) K 2060:1
*# HP k 2013:1

END DOFOR AGE


DOFOR AGE=  '1519' '5054' '70'
   SET %S('PSH'+SEX+AGE) 1979:1 2060:1 = %IF(t<=2013:1,%S('PTSH'+SEX+AGE),%S('LIM'+SEX+AGE))
*	GRAPH(SUBHEADER=AGE+SEX) 2
*	 # %S('PSH'+SEX+AGE) 1979:1 2060:1
*	 # %S('HPPTSH'+SEX+AGE) 1979:1 2013:1
END DOFOR AGE

*************************************************************************************************************************************




DECLARE LABEL AGE SEX  ;* THIS CODE PUTS ALL THE FORECASTS INTO A CONSISTENT NAMED SERIES
* FPTSH DENOTES (F) FORECAST (PTSH) PART TIME SHARE
dedit(new) "OUTPUT_PTSHARES_ 1978_79 to 2059_60 PRJ.rat"
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
		DOFOR SEX = 'F' 'M'
				SET %S('FPTSH'+SEX+AGE) = %IF(t<=2013:1,%s('PTSH'+SEX+AGE),%s('PSH'+SEX+AGE))
				store %S('FPTSH'+SEX+AGE)
				SAVE
END DOFOR SEX
END DOFOR AGE


* copy FORECAST data to an output file
open copy "OUTPUT_Part time share forecasts 1978_79 to 2059_60.XLS"
copy(dates,format=xls,org=columns) 1979:1 2060:1 $
FPTSHf1519 FPTSHm1519  $
FPTSHf2024 FPTSHm2024  $
FPTSHf2529 FPTSHm2529  $
FPTSHf3034 FPTSHm3034  $
FPTSHf3539 FPTSHm3539  $
FPTSHf4044 FPTSHm4044  $
FPTSHf4549 FPTSHm4549  $
FPTSHf5054 FPTSHm5054  $
FPTSHf5559 FPTSHm5559  $
FPTSHf6064 FPTSHm6064  $
FPTSHf6569 FPTSHm6569  $
FPTSHf70 FPTSHm70









*graph part rate forecasts
SET GRID 1979:1 2060:1 = (T==2013:1)
DECLARE LABEL AGE
grparm axislabelling 36 keylabelling 36 subheader 36
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
COMPUTE SUBHEADER = 'Females aged '+age+' years'
graph(subheader=subheader,noPATTERNS,VTICKS=5,ticks,grid=grid) 1
# %S('FPTSH'+'F'+age) 1979:1 2060:1  4
END DOFOR AGE
SPGRAPH(DONE)


DECLARE LABEL AGE
grparm axislabelling 48 keylabelling 48 subheader 48
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
COMPUTE SUBHEADER = 'Males aged '+age+' years'
graph(subheader=subheader,noPATTERNS,VTICKS=5,ticks,grid=grid) 1
# %S('FPTSH'+'m'+age) 1979:1 2060:1  1
END DOFOR AGE
SPGRAPH(DONE)

DECLARE LABEL AGE
grparm axislabelling 48 keylabelling 48 subheader 48
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
COMPUTE SUBHEADER = 'Both genders aged '+age+' years'
graph(subheader=subheader,noPATTERNS,VTICKS=5,ticks,grid=grid) 2
# %S('FPTSH'+'m'+age) 1979:1 2060:1  1
# %S('FPTSH'+'F'+age) 1979:1 2060:1  4
END DOFOR AGE
SPGRAPH(DONE)

DOFOR SEX = 'M' 'F'
		DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
			DISP AGE  %S('FPTSH'+SEX+AGE)(2012:1)  '    ' %S('FPTSH'+SEX+AGE)(2060:1)
		END DOFOR AGE
END DOFOR SEX




