calendar 1979:1
allocate 2060:1
open data "INPUT_average hours by sex and age 1978-79 to 2012-13.xls"
data(format=xls,org=rows,noverbose) 1979:1 2013:1


****************************************************************************************************************************
*                                           Program written by Ralph Lattimore June 2013                                                            *
*****************************************************************************************************************************

DECLARE LABEL AGE SEX WORKTYPE CATEGORY

* PROJECTIONS ARE GOING INTO A FORMAT OF %S('PAVHRS'+WORKTYPE+SEX+AGE)  WHERE P DENOTES PREDICTIONS
* UNITS ARE WEEKLY AVERAGE HOURS



*MODEL CHOICE ANALYSIS
*DOFOR AGE ='1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
*       DOFOR SEX = 'm' 'F'
*         	DOFOR WORKTYPE = 'fT' 'PT'
*					*@DFUNIT(LAGS=1,METHOD=GTOS,SIGNIF=0.1) %s('AVHRS'+worktype+sex+age) 1991:1 2013:1
*					@bjautofit(constant,pmax=5,qmax=5,diffs=0,crit=sbc) %s('AVHRS'+worktype+sex+age)
*				END DOFOR WORKTYPE
*       END DOFOR SEX
*END DOFOR AGE


DOFOR AGE ='1519' '2024' '3034' '4549' '5054' '5559' '6064' '6569' '70'
       DOFOR SEX = 'M'
         	DOFOR WORKTYPE = 'PT'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=0,define=ar1) %S('AVHRS'+WORKTYPE+SEX+AGE)
						uforecast(equation=AR1) f_AVHRS 2014:1 2060:1
						graph(subheader=age+sex+worktype) 2
						# %S('AVHRS'+WORKTYPE+SEX+AGE)
						# f_AVHRS
						SET %S('FAVHRS'+WORKTYPE+SEX+AGE)  = %IF(T<=2013:1,%S('AVHRS'+WORKTYPE+SEX+AGE),F_AVHRS)
				END DOFOR WORKTYPE
       END DOFOR SEX
END DOFOR AGE

DOFOR AGE ='1519' '2024' '2529' '3034'
       DOFOR SEX = 'M'
         	DOFOR WORKTYPE = 'FT'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=0,define=ar1) %S('AVHRS'+WORKTYPE+SEX+AGE)
						uforecast(equation=AR1) f_AVHRS 2014:1 2060:1
						graph(subheader=age+sex+worktype) 2
						# %S('AVHRS'+WORKTYPE+SEX+AGE)
						# f_AVHRS
						SET %S('FAVHRS'+WORKTYPE+SEX+AGE)  = %IF(T<=2013:1,%S('AVHRS'+WORKTYPE+SEX+AGE),F_AVHRS)
				END DOFOR WORKTYPE
       END DOFOR SEX
END DOFOR AGE


DOFOR AGE ='1519' '2024' '3034' '5559' '6064'
       DOFOR SEX = 'F'
         	DOFOR WORKTYPE = 'PT'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=0,define=AR1) %S('AVHRS'+WORKTYPE+SEX+AGE)
						uforecast(equation=AR1) f_AVHRS 2014:1 2060:1
						graph(subheader=age+sex+worktype) 2
						# %S('AVHRS'+WORKTYPE+SEX+AGE)
						# f_AVHRS
						SET %S('FAVHRS'+WORKTYPE+SEX+AGE)  = %IF(T<=2013:1,%S('AVHRS'+WORKTYPE+SEX+AGE),F_AVHRS)
				END DOFOR WORKTYPE
       END DOFOR SEX
END DOFOR AGE

DOFOR AGE = '2529' '4549' '5054'
       DOFOR SEX = 'F'
         	DOFOR WORKTYPE = 'PT'
          			BOXJENK(NOPRINT,DIFF=1,AR=0,MA=0,define=ARIMA010) %S('AVHRS'+WORKTYPE+SEX+AGE)
						uforecast(equation=ARIMA010) f_AVHRS 2014:1 2060:1
						graph(subheader=age+sex+worktype) 2
						# %S('AVHRS'+WORKTYPE+SEX+AGE)
						# f_AVHRS
						SET %S('FAVHRS'+WORKTYPE+SEX+AGE)  = %IF(T<=2013:1,%S('AVHRS'+WORKTYPE+SEX+AGE),F_AVHRS)
				END DOFOR WORKTYPE
       END DOFOR SEX
END DOFOR AGE



DOFOR AGE = '1519' '2024' '3539' '4044' '4549'
       DOFOR SEX = 'F'
         	DOFOR WORKTYPE = 'FT'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=0,define=AR1) %S('AVHRS'+WORKTYPE+SEX+AGE)
						uforecast(equation=AR1) f_AVHRS 2014:1 2060:1
						graph(subheader=age+sex+worktype) 2
						# %S('AVHRS'+WORKTYPE+SEX+AGE)
						# f_AVHRS
						SET %S('FAVHRS'+WORKTYPE+SEX+AGE)  = %IF(T<=2013:1,%S('AVHRS'+WORKTYPE+SEX+AGE),F_AVHRS)
				END DOFOR WORKTYPE
       END DOFOR SEX
END DOFOR AGE

DOFOR CATEGORY = 'AVHRSFTM3539' 'AVHRSFTM4044' 'AVHRSPTF3539' 'AVHRSPTF4044' 'AVHRSFTF2529' 'AVHRSFTF3034'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=0,define=AR1) %S(CATEGORY)
						uforecast(equation=AR1) f_AVHRS 2014:1 2060:1
						graph(subheader=CATEGORY) 2
						# %S(CATEGORY)
						# f_AVHRS
						SET %S('F'+CATEGORY)  = %IF(T<=2013:1,%S(CATEGORY),F_AVHRS)
END DOFOR CATEGORY



DOFOR CATEGORY = 'AVHRSFTM6569' 'AVHRSFTM70'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=1,define=ARMA11) %S(CATEGORY)
						uforecast(equation=ARMA11) f_AVHRS 2014:1 2060:1
						graph(subheader=CATEGORY) 2
						# %S(CATEGORY)
						# f_AVHRS
						SET %S('F'+CATEGORY)  = %IF(T<=2013:1,%S(CATEGORY),F_AVHRS)
END DOFOR CATEGORY

DOFOR CATEGORY = 'AVHRSFTF6569' 'AVHRSFTF70'
          			BOXJENK(NOPRINT,DIFF=1,AR=0,MA=0,define=ARIMA010) %S(CATEGORY)
						uforecast(equation=ARIMA010) f_AVHRS 2014:1 2060:1
						graph(subheader=CATEGORY) 2
						# %S(CATEGORY)
						# f_AVHRS
						SET %S('F'+CATEGORY)  = %IF(T<=2013:1,%S(CATEGORY),F_AVHRS)
END DOFOR CATEGORY


DOFOR CATEGORY = 'AVHRSPTF6569' 'AVHRSPTF70' 'AVHRSFTF6064'
          			BOXJENK(NOPRINT,CONST,AR=2,ma=0,define=ar2) %S(CATEGORY)
						uforecast(equation=AR2) f_AVHRS 2014:1 2060:1
						graph(subheader=CATEGORY) 2
						# %S(CATEGORY)
						# f_AVHRS
						SET %S('F'+CATEGORY)  = %IF(T<=2013:1,%S(CATEGORY),F_AVHRS)
END DOFOR CATEGORY

DOFOR CATEGORY = 'AVHRSPTM2529' 'AVHRSPTM4044' 'AVHRSFTM5559' 'AVHRSFTF5559'
          			BOXJENK(NOPRINT,CONST,AR=2,ma=0,define=AR2) %S(CATEGORY)
						uforecast(equation=AR2) f_AVHRS 2014:1 2060:1
						graph(subheader=CATEGORY) 2
						# %S(CATEGORY)
						# f_AVHRS
						SET %S('F'+CATEGORY)  = %IF(T<=2013:1,%S(CATEGORY),F_AVHRS)
END DOFOR CATEGORY

DOFOR CATEGORY = 'AVHRSPTM3539' 'AVHRSFTM4549' 'AVHRSFTF5054'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=3,define=ARMA13) %S(CATEGORY)
						uforecast(equation=ARMA13) f_AVHRS 2014:1 2060:1
						graph(subheader=CATEGORY) 2
						# %S(CATEGORY)
						# f_AVHRS
						SET %S('F'+CATEGORY)  = %IF(T<=2013:1,%S(CATEGORY),F_AVHRS)
END DOFOR CATEGORY


DOFOR CATEGORY = 'AVHRSFTM5054'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=0,define=ar1) %S(CATEGORY)
						uforecast(equation=AR1) f_AVHRS 2014:1 2060:1
						graph(subheader=CATEGORY) 2
						# %S(CATEGORY)
						# f_AVHRS
						SET %S('F'+CATEGORY)  = %IF(T<=2013:1,%S(CATEGORY),F_AVHRS)
END DOFOR CATEGORY

DOFOR CATEGORY = 'AVHRSFTM6064'
          			BOXJENK(NOPRINT,CONST,AR=1,ma=2,define=ARMA12) %S(CATEGORY)
						uforecast(equation=ARMA12) f_AVHRS 2014:1 2060:1
						graph(subheader=CATEGORY) 2
						# %S(CATEGORY)
						# f_AVHRS
						SET %S('F'+CATEGORY) = %IF(T<=2013:1,%S(CATEGORY),F_AVHRS)
END DOFOR CATEGORY


****************************************************
*DOFOR AGE ='1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
*    DOFOR WORKTYPE = 'FT' 'PT'
*            SET %s('LAVHRS'+worktype+'M'+age) = LOG(%s('AVHRS'+worktype+'M'+age))
*            SET %s('LAVHRS'+worktype+'F'+age) = LOG(%s('AVHRS'+worktype+'F'+age))
*				LINREG(DEFINE=HEQT) %s('LAVHRS'+worktype+'F'+age)
*            # CONSTANT %s('LAVHRS'+worktype+'M'+age)
*				PRJ FITTED
*				graph(subheader='LOG HOURS'+worktype+'F'+age) 2
*				# %s('LAVHRS'+worktype+'F'+age)
*				# FITTED
*	END DOFOR WORKTYPE
*END DOFOR AGE







grparm vlabel 40 keylabeling 36 axislabelling 40 subheader 40
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE ='1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
         	DOFOR WORKTYPE = 'FT'
					graph(subheader=age,key=attached,klabels=||"Males","Females"||) 2
					# %s('fAVHRS'+worktype+'M'+age)
					# %s('fAVHRS'+worktype+'F'+age)
				END DOFOR WORKTYPE
END DOFOR AGE
spgraph(done)

grparm vlabel 40 keylabeling 36 axislabelling 40 subheader 40
SPGRAPH(HFIELD=3,vfield=4)
DOFOR AGE ='1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
         	DOFOR WORKTYPE = 'pT'
					graph(subheader=age,key=attached,klabels=||"Males","Females"||) 2
					# %s('fAVHRS'+worktype+'M'+age)
					# %s('fAVHRS'+worktype+'F'+age)
				END DOFOR WORKTYPE
END DOFOR AGE
spgraph(done)



dedit(new) "OUTPUT_AVHRS 1978-79 TO 2059-60_PRJ.rat"
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
     DOFOR WORKTYPE = 'pT' 'ft'
			DOFOR SEX = 'F' 'M'
					store %S('Favhrs'+worktype+SEX+AGE)
					SAVE
			END DOFOR SEX
		end dofor worktype
END DOFOR AGE



* copy FORECAST data to an output file
open copy "OUTPUT_Average hours forecasts 1978_79 to 2059_60.XLS"
copy(dates,format=xls,org=columns) 1979:1 2060:1 $
FAVHRSPTf1519 FAVHRSPTf2024 FAVHRSPTf2529 FAVHRSPTf3034 FAVHRSPTf3539 FAVHRSPTf4044 FAVHRSPTf4549 FAVHRSPTf5054 FAVHRSPTf5559 FAVHRSPTf6064 FAVHRSPTf6569 FAVHRSPTf70 $
FAVHRSPTM1519 FAVHRSPTM2024 FAVHRSPTM2529 FAVHRSPTM3034 FAVHRSPTM3539 FAVHRSPTM4044 FAVHRSPTM4549 FAVHRSPTM5054 FAVHRSPTM5559 FAVHRSPTM6064 FAVHRSPTM6569 FAVHRSPTM70 $
FAVHRSFTF1519 FAVHRSFTF2024 FAVHRSFTF2529 FAVHRSFTF3034 FAVHRSFTF3539 FAVHRSFTF4044 FAVHRSFTF4549 FAVHRSFTF5054 FAVHRSFTF5559 FAVHRSFTF6064 FAVHRSFTF6569 FAVHRSFTF70 $
FAVHRSFTM1519 FAVHRSFTM2024 FAVHRSFTM2529 FAVHRSFTM3034 FAVHRSFTM3539 FAVHRSFTM4044 FAVHRSFTM4549 FAVHRSFTM5054 FAVHRSFTM5559 FAVHRSFTM6064 FAVHRSFTM6569 FAVHRSFTM70

*NOTE that the ultimate level of average hours is adjusted in RATS pgm '6 gdp PROJECTIONS TO 2059_60.PRG'


