calendar 1971:1
allocate 2060:1
open data "INPUT_Labour force 1978_79 to 2012_13.xls"
data(format=xls,org=rows,noverbose) 1979:1  2013:1
open data "INPUT_Population estimates 1970-71 to 2059-60.xls"
data(format=xls,org=rows,noverbose) 1971:1  2060:1



****************************************************************************************************************************
*                                           Program written by Ralph Lattimore June 2013                                                            *
*****************************************************************************************************************************

DECLARE LABEL AGE SEX

* PROJECTIONS ARE GOING INTO A FORMAT OF %S(FCPOP_RATIO'+SEX+AGE)  WHERE F DENOTES FORECASTS
dedit(new) "OUTPUT_CPOP_RATIO 1971-72 TO 2059_60_PRJ.rat"
DOFOR AGE ='1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
       DOFOR SEX = 'M' 'F'
                  SET %S('FMAPOP'+SEX+AGE) = 1./2.*(%S('POP'+SEX+AGE)(T)+%S('POP'+SEX+AGE)(T-1)) ;* IN PERSONS
          			SET %S('RATIO'+SEX+AGE)  = 1000.*%S('CPOP'+SEX+AGE)(T)/%S('FMAPOP'+SEX+AGE)(T) ;*TAKES ACCOUNT OF FACT CPOP WAS IN '000s of people
          			SET %S('FCPOP_RATIO'+SEX+AGE)  =  %IF(T<=2013:1,%S('RATIO'+SEX+AGE) ,%S('RATIO'+SEX+AGE)(2013:1))
						store %S('FCPOP_RATIO'+SEX+AGE)
						STORE %S('FMAPOP'+SEX+AGE)
						SAVE
       END DOFOR SEX
END DOFOR AGE
*DISP RATIOM2024(2013:1)   FMAPOPM2024(2060:1) popm2024(2060:1)



* copy FORECAST data to an output file
open copy "OUTPUT_civilian population to population ratio 2011_12 to 2059_60.XLS"
copy(dates,format=xls,org=columns) 1979:1 2060:1 $
FCPOP_RATIOf1519 FCPOP_RATIOm1519  $
FCPOP_RATIOf2024 FCPOP_RATIOm2024  $
FCPOP_RATIOf2529 FCPOP_RATIOm2529  $
FCPOP_RATIOf3034 FCPOP_RATIOm3034  $
FCPOP_RATIOf3539 FCPOP_RATIOm3539  $
FCPOP_RATIOf4044 FCPOP_RATIOm4044  $
FCPOP_RATIOf4549 FCPOP_RATIOm4549  $
FCPOP_RATIOf5054 FCPOP_RATIOm5054  $
FCPOP_RATIOf5559 FCPOP_RATIOm5559  $
FCPOP_RATIOf6064 FCPOP_RATIOm6064  $
FCPOP_RATIOf6569 FCPOP_RATIOm6569  $
FCPOP_RATIOf70 FCPOP_RATIOm70 $
FMAPOPf1519 FMAPOPm1519  $
FMAPOPf2024 FMAPOPm2024  $
FMAPOPf2529 FMAPOPm2529  $
FMAPOPf3034 FMAPOPm3034  $
FMAPOPf3539 FMAPOPm3539  $
FMAPOPf4044 FMAPOPm4044  $
FMAPOPf4549 FMAPOPm4549  $
FMAPOPf5054 FMAPOPm5054  $
FMAPOPf5559 FMAPOPm5559  $
FMAPOPf6064 FMAPOPm6064  $
FMAPOPf6569 FMAPOPm6569  $
FMAPOPf70 FMAPOPm70



