

calendar 1979
allocate 2060:1
open data "INPUT_Labour force 1978_79 to 2012_13.xls"
data(format=xls,org=rows,noverbose) 1979:1 2013:1
SOURCE(NOECHO) "HPFILTER.SRC"


/*
Disp 'The symbols /* and */ bracketing any expression prevent RATS from operating on the code
*/


DECLARE LABEL AGE SEX
DOFOR AGE = '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
     SET(SCRATCH) %S('EMPRATE'+SEX+AGE) = %S('E'+SEX+AGE)/%S('LF'+SEX+AGE)
     @HPFILTER(LAMBDA=100)  %S('EMPRATE'+SEX+AGE)  1979:1  2013:1  %S('HPER'+SEX+AGE)
end dofor sex
end dofor AGE


* INITIALLY PROJECTIONS ARE GOING INTO A FORMAT OF %S('PEMPRATE'+SEX+AGE)  SO CREATE THESE NOW
DOFOR AGE = '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
       DOFOR SEX = 'M' 'F'
          SET %S('PEMPRATE'+SEX+AGE) = %IF(t<=2013:1,%S('EMPRATE'+SEX+AGE),0.0)
       END DOFOR SEX
END DOFOR AGE

DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
       DOFOR SEX = 'M' 'F'
         SET %S('DHPER'+SEX+AGE) = %S('HPER'+SEX+AGE)-%S('HPER'+SEX+AGE)(T-1)
         SET %S('DDHPER'+SEX+AGE) = %S('DHPER'+SEX+AGE)-%S('DHPER'+SEX+AGE)(T-1)
        END DOFOR SEX
END DOFOR AGE



DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
	dofor sex = 'm' 'f'
 		set %s('hper_p'+sex+age) = 100.*%s('hper'+sex+age)
 		set %s('emprate_p'+sex+age) = 100.*%s('emprate'+sex+age)
	end dofor sex
END dofor AGE







************************************000000000000000000000000******************************************




/*

grparm AXISlabelling 12 keylabelling 12 subheader 12
* DIFFERENCING OF EMPLOYMENT RATES
compute sex = 'M'
	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		SPGRAPH(vFIELD=3)
		COMPUTE SUBHEADER = sex+age+'  years   '

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   	# %S('HPER'+sex+age) 1981:1 2013:1  1
   	# %S('EMPRATE'+sex+age) 1981:1 2013:1  4


		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('DHPER'+sex+age) 1981:1 2013:1  1

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('DDHPER'+sex+age) 1981:1 2013:1  1
	SPGRAPH(DONE)

	END dofor AGE

compute sex = 'F'
	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		SPGRAPH(vFIELD=3)
		COMPUTE SUBHEADER = sex+age+'  years   '

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 2
   	# %S('hpEr'+sex+age) 1981:1 2013:1  1
   	# %S('EMPRATE'+sex+age) 1981:1 2013:1  4


		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('dhpEr'+sex+age) 1981:1 2013:1  1

		graph(subheader=subheader,noPATTERns,DATES,VTICKS=5) 1
   	# %S('ddhpEr'+sex+age) 1981:1 2013:1  1
	SPGRAPH(DONE)
	END dofor AGE

grparm vlabel 40 keylabeling 40 axislabelling 36 subheader 40
compute start = 1979:1
compute end = 2013:1
SPGRAPH(HFIELD=3,vfield=4)
	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		GRAPH(SUBHEADER=AGE,patterns,vticks=6,key=attached,klabels=||"HPM","ERM","HPF","ERF"||) 4
		# %S('hpErm'+age) START END 11
		# %S('EMPRATEM'+age) START END 2
		# %S('hpErF'+age) START END  12
		# %S('EMPRATEF'+age) START END  2
	END DOFOR AGE
SPGRAPH(DONE)


grparm vlabel 50 keylabeling 50 axislabelling 50 subheader 50
compute start = 1979:1
compute end = 2013:1
SPGRAPH(HFIELD=3,vfield=4)
	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		set %s('URM'+AGE) = (100.-%S('EMPRATE_pM'+AGE))
		set %s('HPURM'+AGE) = (100.-%S('HPER_pM'+AGE))
		GRAPH(SUBHEADER=AGE,patterns,vticks=6) 2
		# %S('HPURM'+age) START END 11
		# %S('URM'+age) START END 12
	END DOFOR AGE
SPGRAPH(DONE)

grparm vlabel 50 keylabeling 50 axislabelling 50 subheader 50
compute start = 1979:1
compute end = 2013:1
SPGRAPH(HFIELD=3,vfield=4)
	DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569'  '70'
		set %s('URF'+AGE) = (100.-%S('EMPRATE_pF'+AGE))
		set %s('HPURF'+AGE) = (100.-%S('HPER_pF'+AGE))
		GRAPH(patterns,vticks=6) 2
		# %S('hpURF'+age) START END 11
		# %S('URF'+age) START END 12
	END DOFOR AGE
SPGRAPH(DONE)



* copy FORECAST data to an output file
open copy "OUTPUT_unemployment rates by age and sex 1978_79 to 2012-13.XLS"
copy(dates,format=xls,org=columns) 1979:1 2013:1 $
urf1519 urm1519  $
urf2024 urm2024  $
urf2529 urm2529  $
urf3034 urm3034  $
urf3539 urm3539  $
urf4044 urm4044  $
urf4549 urm4549  $
urf5054 urm5054  $
urf5559 urm5559  $
urf6064 urm6064  $
urf6569 urm6569  $
urf70 urm70 $
hpurf1519 hpurm1519  $
hpurf2024 hpurm2024  $
hpurf2529 hpurm2529  $
hpurf3034 hpurm3034  $
hpurf3539 hpurm3539  $
hpurf4044 hpurm4044  $
hpurf4549 hpurm4549  $
hpurf5054 hpurm5054  $
hpurf5559 hpurm5559  $
hpurf6064 hpurm6064  $
hpurf6569 hpurm6569  $
hpurf70 hpurm70
*/


*THE LAST FEW YEARS HAVE SEEN LOW INFLATION AND LOW AND STABLE UNEMPLOYMENT RATES
*ON THIS BASIS RECENT EMPLOYMENT RATES ARE SEEN AS REASONABLE PROXIES FOR THE AGE-SPECIFIC NAIRU,
*EXCEPT WHERE OTHER FACTORS ARE AT WORK
*NOTE THAT EMPLOYMENT RATES APPEAR TO BE RISING FOT THE OLDEST PEOPLE, WHO ARE ALSO EXPERIENCING THE GREATEST INCREASE IN
*PARTICIPATION RATES. THIS IS CONSISTENT WITH THE NOTION THAT PEOPLE WANTING TO ENTER THE LABOUR MARKET MAY NEED TO SEARCH
*ACCORDINGLY, THERE IS A TREND FOR THESE GROUPS TO BE CONSIDERED


declare integer k
SET TREND = T
*MALES

COMPUTE SEX = 'M'

SET %S('LIM'+SEX+'1519') = %S('HPER'+SEX+'1519')(2013:1)
SET %S('LIM'+SEX+'2024') = %S('HPER'+SEX+'2024')(2013:1)
SET %S('LIM'+SEX+'2529') = %S('HPER'+SEX+'2529')(2013:1)
SET %S('LIM'+SEX+'3034') = %S('HPER'+SEX+'3034')(2013:1)
SET %S('LIM'+SEX+'3539') = %S('HPER'+SEX+'3539')(2013:1)
SET %S('LIM'+SEX+'4044') = %S('HPER'+SEX+'4044')(2013:1)
SET %S('LIM'+SEX+'4549') = %S('HPER'+SEX+'4549')(2013:1)
SET %S('LIM'+SEX+'5054') = %S('HPER'+SEX+'5054')(2013:1)
SET %S('LIM'+SEX+'5559') = %S('HPER'+SEX+'5559')(2013:1)
SET %S('LIM'+SEX+'6064') = %S('HPER'+SEX+'6064')(2013:1)

SET %S('LIM'+SEX+'6569') = 0.975
SET %S('ST'+SEX+'6569') = 2006:1
SET %S('FLEX'+SEX+'6569') =2013:1

SET %S('LIM'+SEX+'70') = 0.975
SET %S('ST'+SEX+'70') = 2001:1
SET %S('FLEX'+SEX+'70') = 2013:1

* NOW ESTIMATE RICHARDS CURVES
COMPUTE SEX = 'M'
DOFOR AGE=  '6569' '70'
   COMPUTE K = FIX(%S('ST'+SEX+AGE)(1))  ;* POINT OF THE STRUCTURAL BREAK
   SET TREND2 = TREND-K   ;* RESETS T SO THAT IT IS ZERO AT THE POINT WHERE A STRUCTURAL BREAK HAS BEEN DETECTED
   COMPUTE FLEX = %S('FLEX'+SEX+AGE)(2013:1)-K  ;* THE ESTIMATED INFLECTION POINT OF THE RICHARDS RELATIVE TO THE CORRECTED STARTING VALUE
   SET HP = %S('HPER'+SEX+AGE)   ;* SMOOTHED (HODRICK-PRESCOTT) EMPLOYMENT RATES
   COMPUTE POS = %IF(HP(2013:1)-HP(K)>0,1.0,-1.0)
   COMPUTE LIM = %S('LIM'+SEX+AGE)(2013:1);* THIS IS THE MAX OR MIN VALUE OF THE RATE
   COMPUTE SIGN = %IF(LIM<0,-1.0,1.0)
   * INITIAL STATES OF RICHARDS PARAMETERS FOR NLLS
   COMPUTE LAMBDA = -1.0  ;* THIS IS THE LOGISTIC
   COMPUTE PHI = -3.0 ;* THIS MEANS THAT THE INITIAL VALUE OF PHI IS S.T. THE LONG RUN IS AROUND 95% OF THE LIMIT
   COMPUTE GROW = SQRT(0.15)
  * DISP K FLEX POS LIM SIGN LAMBDA PHI GROW

   NONLIN GROW PHI LAMBDA
   FRML G = -GROW*GROW
   FRML BETA = (-1.0/LAMBDA)*EXP(-G*FLEX) ;* BASED ON THE RELATIONSHIP BETWEEN BETA AND G AT THE INFLECTION POINT OF A RICHARDS
   FRML LONG =  HP(2013:1)+(1/(1+EXP(PHI)))*(LIM-HP(2013:1))  ;* provides a boundary on the limit of the curve
   FRML ALPHA = (HP(2013:1)-LONG)/(((1+BETA*exp(-GROW*GROW*TREND2(2013:1)))^LAMBDA)-1)
   FRML CON =  LONG-ALPHA
   FRML F1 HP = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   nlls(NOPRINT,frml=f1,ITERATIONS=10000,method=SIMPLEX,cvcrit=0.0000001) HP K 2013:1
   SET %S('PEMPRATE'+SEX+AGE) = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   *DISP AGE'BETA= ' (-1.0/LAMBDA)*EXP(-(-GROW*GROW)*FLEX)  'PHI= ' PHI 'G= ' GROW 'LAMBDA = ' LAMBDA 'LIMIT= ' LIM

*GRAPH(SUBHEADER=AGE+SEX) 2
*# %S('PEMPRATE'+SEX+AGE) K 2060:1
*# HP K 2013:1

END DOFOR AGE


DOFOR AGE=  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064'
   SET %S('PEMPRATE'+SEX+AGE) 1979:1 2060:1 = %IF(t<=2013:1,%S('EMPRATE'+SEX+AGE),%S('LIM'+SEX+AGE))
*	GRAPH(SUBHEADER=AGE+SEX) 2
*	 # %S('PEMPRATE'+SEX+AGE) 1979:1 2060:1
*	 # %S('HPER'+SEX+AGE) 1979:1 2013:1
END DOFOR AGE


*FEMALES

COMPUTE SEX = 'F'

SET %S('LIM'+SEX+'1519') = %S('HPER'+SEX+'1519')(2013:1)
SET %S('LIM'+SEX+'2024') = %S('HPER'+SEX+'2024')(2013:1)
SET %S('LIM'+SEX+'2529') = %S('HPER'+SEX+'2529')(2013:1)
SET %S('LIM'+SEX+'3034') = %S('HPER'+SEX+'3034')(2013:1)
SET %S('LIM'+SEX+'3539') = %S('HPER'+SEX+'3539')(2013:1)
SET %S('LIM'+SEX+'4044') = %S('HPER'+SEX+'4044')(2013:1)
SET %S('LIM'+SEX+'4549') = %S('HPER'+SEX+'4549')(2013:1)
SET %S('LIM'+SEX+'5054') = %S('HPER'+SEX+'5054')(2013:1)
SET %S('LIM'+SEX+'5559') = %S('HPER'+SEX+'5559')(2013:1)


SET %S('LIM'+SEX+'6064') = 0.965
SET %S('ST'+SEX+'6064') = 2001:1
SET %S('FLEX'+SEX+'6064') =2011:1

SET %S('LIM'+SEX+'6569') = %S('HPER'+SEX+'6569')(2013:1)

SET %S('LIM'+SEX+'70') = 0.98
SET %S('ST'+SEX+'70') = 2005:1
SET %S('FLEX'+SEX+'70') = 2013:1




* NOW ESTIMATE RICHARDS CURVES
COMPUTE SEX = 'F'
DOFOR AGE=  '6064' '70'
   COMPUTE K = FIX(%S('ST'+SEX+AGE)(1))  ;* POINT OF THE STRUCTURAL BREAK
   SET TREND2 = TREND-K   ;* RESETS T SO THAT IT IS ZERO AT THE POINT WHERE A STRUCTURAL BREAK HAS BEEN DETECTED
   COMPUTE FLEX = %S('FLEX'+SEX+AGE)(2013:1)-K  ;* THE ESTIMATED INFLECTION POINT OF THE RICHARDS RELATIVE TO THE CORRECTED STARTING VALUE
   SET HP = %S('HPER'+SEX+AGE)   ;* SMOOTHED (HODRICK-PRESCOTT) EMPLOYMENT RATES
   COMPUTE POS = %IF(HP(2013:1)-HP(K)>0,1.0,-1.0)
   COMPUTE LIM = %S('LIM'+SEX+AGE)(2013:1);* THIS IS THE MAX OR MIN VALUE OF THE RATE
   COMPUTE SIGN = %IF(LIM<0,-1.0,1.0)
   * INITIAL STATES OF RICHARDS PARAMETERS FOR NLLS
   COMPUTE LAMBDA = -1.0  ;* THIS IS THE LOGISTIC
   COMPUTE PHI = -3.0 ;* THIS MEANS THAT THE INITIAL VALUE OF PHI IS S.T. THE LONG RUN IS AROUND 95% OF THE LIMIT
   COMPUTE GROW = SQRT(0.15)
  * DISP K FLEX POS LIM SIGN LAMBDA PHI GROW

   NONLIN GROW PHI LAMBDA
   FRML G = -GROW*GROW
   FRML BETA = (-1.0/LAMBDA)*EXP(-G*FLEX) ;* BASED ON THE RELATIONSHIP BETWEEN BETA AND G AT THE INFLECTION POINT OF A RICHARDS
   FRML LONG =  HP(2013:1)+(1/(1+EXP(PHI)))*(LIM-HP(2013:1))  ;* provides a boundary on the limit of the curve
   FRML ALPHA = (HP(2013:1)-LONG)/(((1+BETA*exp(-GROW*GROW*TREND2(2013:1)))^LAMBDA)-1)
   FRML CON =  LONG-ALPHA
   FRML F1 HP = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   nlls(NOPRINT,frml=f1,ITERATIONS=10000,method=SIMPLEX,cvcrit=0.0000001) HP K 2013:1
   SET %S('PEMPRATE'+SEX+AGE) = CON+ALPHA*(1.0+BETA*EXP(G*TREND2))^LAMBDA
   *DISP AGE'BETA= ' (-1.0/LAMBDA)*EXP(-(-GROW*GROW)*FLEX)  'PHI= ' PHI 'G= ' GROW 'LAMBDA = ' LAMBDA 'LIMIT= ' LIM

*GRAPH(SUBHEADER=AGE+SEX) 2
*# %S('PEMPRATE'+SEX+AGE) K 2060:1
*# HP k 2013:1

END DOFOR AGE


DOFOR AGE=  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6569'
   SET %S('PEMPRATE'+SEX+AGE) 1979:1 2060:1 = %IF(t<=2013:1,%S('EMPRATE'+SEX+AGE),%S('LIM'+SEX+AGE))

*GRAPH(SUBHEADER=AGE+SEX) 2
*# %S('PEMPRATE'+SEX+AGE) 1979:1 2060:1
*# %S('HPER'+SEX+AGE) 1979:1 2013:1

END DOFOR AGE




disp 'male unemployment rates aged 70+ in 2012:1 and predicted for 2059-60 are: ' 100.*(1-pempratem70(2012:1)) 100*(1-pempratem70(2060:1))
disp 'male unemployment rates aged 6569 in 2012:1 and predicted for 2059-60 are: ' 100.*(1-pempratem6569(2012:1)) 100*(1-pempratem6569(2060:1))
disp 'female unemployment rates aged 70+ in 2012:1 and predicted for 2059-60 are: ' 100.*(1-pempratef70(2012:1)) 100*(1-pempratef70(2060:1))
disp 'female unemployment rates aged 6064 in 2012:1 and predicted for 2059-60 are: ' 100.*(1-pempratef6064(2012:1)) 100*(1-pempratef6064(2060:1))
male unemployment rates aged 70+ in 2012:1 and predicted for 2059-60 are:        1.23217       2.49714
male unemployment rates aged 6569 in 2012:1 and predicted for 2059-60 are:        1.63077       2.42324
female unemployment rates aged 70+ in 2012:1 and predicted for 2059-60 are:        1.12587       2.00000
female unemployment rates aged 6064 in 2012:1 and predicted for 2059-60 are:        2.69370       3.49968




***********************************************************************************************************************


* THIS CODE PUTS ALL THE FORECASTS INTO A CONSISTENT NAMED SERIES

dedit(new) "OUTPUT_EMPRATES_1978_79 to 2059_60 PRJ.rat"
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
		DOFOR SEX = 'F' 'M'
			       	SET %S('FEMPRATE'+SEX+AGE) = %IF(t<=2013:1,%S('EMPRATE'+SEX+AGE),%S('PEMPRATE'+SEX+AGE))
						store %S('FEMPRATE'+SEX+AGE)
			SAVE
		END DOFOR SEX
END DOFOR AGE




* copy FORECAST data to an output file
open copy "OUTPUT_Employment rates by age and sex 1978_79 to 2059_60.XLS"
copy(dates,format=xls,org=columns) 1979:1 2060:1 $
FEMPRATEf1519 FEMPRATEm1519  $
FEMPRATEf2024 FEMPRATEm2024  $
FEMPRATEf2529 FEMPRATEm2529  $
FEMPRATEf3034 FEMPRATEm3034  $
FEMPRATEf3539 FEMPRATEm3539  $
FEMPRATEf4044 FEMPRATEm4044  $
FEMPRATEf4549 FEMPRATEm4549  $
FEMPRATEf5054 FEMPRATEm5054  $
FEMPRATEf5559 FEMPRATEm5559  $
FEMPRATEf6064 FEMPRATEm6064  $
FEMPRATEf6569 FEMPRATEm6569  $
FEMPRATEf70 FEMPRATEm70







