calendar 1960:1
allocate 2060:1

*************************************************************************************************
*                                                                                               *
*                  [1] INPUT DATA                                                               *
*                                                                                               *
**************************************************************************************************
*All ratios of variables from input series are in ratio not % form

open daTA  "INPUT_GDP DATA 1959_60 to 2012_13.xls"
data(format=XLS,ORG=cols,NOVERBOSE)  1960:1 2013:1


open daTA "OUTPUT_AVHRS 1978-79 TO 2059-60_PRJ.rat"
data(format=RATS,NOVERBOSE)  1979:1 2060:1


open daTA "OUTPUT_CPOP_RATIO 1971-72 TO 2059_60_PRJ.rat"
data(format=RATS,NOVERBOSE) 1972:1 2060:1


open daTA "OUTPUT_EMPRATES_1978_79 to 2059_60 PRJ.rat"
data(format=RATS,NOVERBOSE) 1979:1 2060:1

open DATA "OUTPUT_PRATES 1978_79 to 2059_60_PRJ.rat"
data(format=RATS,noVERBOSE) 1979:1 2060:1


open DATA "OUTPUT_PTSHARES_ 1978_79 to 2059_60 PRJ.rat"
data(format=RATS,NOVERBOSE) 1979:1 2060:1

open daTA  "lNPUT Labour productivity growth rates.xls"
data(format=XLS,ORG=ROWS,NOVERBOSE)  2012:1 2060:1


open daTA  "INPUT_Population estimates 1970-71 to 2059-60.xls"
data(format=XLS,ORG=ROWS,NOVERBOSE)  1971:1 2060:1

open daTA  "INPUT RNNDI Components 1959-60 to 2059-60.xls"
data(format=XLS,ORG=colS,noVERBOSE)  1960:1 2060:1





DECLARE LABEL AGE SEX worktype
SET TREND = T
SET HRS = 0.0
SET EMP = 0.0
SET CPOP = 0.0
SET LF = 0.0
SET MAPWRK = 0.0
SET PTEMP = 0.0
SET FTEMP = 0.0
SET HRSPT = 0.0
SET HRSFT = 0.0
SET CPOP1564 = 0.0
set cpop1559 = 0.0
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
     	SET MAPWRK = %S('FMAPOP'+SEX+AGE)/1000000.+MAPWRK   ;*MAPWRK IS THE 2 YR MOVING AVERAGE OF THE POPULATION AGED 15+
     	SET %S('CPOP'+SEX+AGE) = %S('FCPOP_RATIO'+SEX+AGE)*%S('FMAPOP'+SEX+AGE)/1000000. ;*FMAPOP IS IN persons
      SET CPOP = CPOP+%S('CPOP'+SEX+AGE)
      SET %S('LF'+SEX+AGE) = %S('FPR'+SEX+AGE)*%S('CPOP'+SEX+AGE)
      SET LF = LF+%S('LF'+SEX+AGE)
      SET %S('EMP'+SEX+AGE) = %S('FEMPRATE'+SEX+AGE)*%S('LF'+SEX+AGE)
      SET EMP = EMP+%S('EMP'+SEX+AGE)
      SET %S('PTEMP'+SEX+AGE) = %S('FPTSH'+SEX+AGE)*%S('EMP'+SEX+AGE)
      SET %S('FTEMP'+SEX+AGE) = %S('EMP'+SEX+AGE)-%S('PTEMP'+SEX+AGE)
      SET FTEMP = %S('FTEMP'+SEX+AGE)+FTEMP
      SET %S('HRSPT'+SEX+AGE) = %S('FAVHRSPT'+SEX+AGE)*%S('PTEMP'+SEX+AGE)*52.0
		SET %S('HRSFT'+SEX+AGE) = %S('FAVHRSFT'+SEX+AGE)*%S('FTEMP'+SEX+AGE)*52.0
      SET %S('HRS'+SEX+AGE) = %S('HRSPT'+SEX+AGE)+%S('HRSFT'+SEX+AGE)
      SET HRSPT = HRSPT+%S('HRSPT'+SEX+AGE)
      SET HRSFT = HRSFT+%S('HRSFT'+SEX+AGE)
      *disp %S('FPR'+SEX+AGE)(2060:1)
  END DOFOR SEX
END DOFOR AGE

DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'f' 'm'
      *disp %S('cpop'+SEX+AGE)(2060:1)*1000000. %S('fpr'+SEX+AGE)(2060:1)*100.
  END DOFOR SEX
END DOFOR AGE





DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064'
  DOFOR SEX = 'M' 'F'
      SET CPOP1564 = CPOP1564+%S('CPOP'+SEX+AGE)
  END DOFOR SEX
END DOFOR AGE

DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559'
  DOFOR SEX = 'M' 'F'
      SET CPOP1559 = CPOP1559+%S('CPOP'+SEX+AGE)
  END DOFOR SEX
END DOFOR AGE




SET HRS = HRSPT+HRSFT
SET PTEMP = EMP-FTEMP
set ptsh = ptemp/emp
set hrs_preadj = hrs





SET POP = POP/1000000.
SET MPOP = (POP+POP(T-1))/2.     ;* THE 2 YR MOVING AVERAGE OF THE TOTAL POPULATION

*************************************************************************************************
*                                                                                               *
*                  [2] KEY MNEMONICS AND UNITS OF MEASUREMENT                                                               *
*                                                                                               *
**************************************************************************************************
* Units for each major variable
* EMP  is PEOPLE IN MILLION
* PTEMP is PART-TIME EMPLOYEES IN MILLION
* FTEMP is FULL-TIME EMPLOYEES IN MILLION
* CPOP is civilian population AGED 15+ in MILLION
* LF is LABOUR FORCE IN MILLION
* MAPWRK IS MOVING AVERAGE OF THE POTENTIAL WORKFORCE (THE CIVILIAN POPULATION AGED 15+ YRS) IN MILLION
* MPOP IS MOVING AVERAGE OF THE POPULATION IN MILLION
* HOURS IS HOURS IN A YEAR (MILLIONS)
* PRODUCTIVITY IS THE RATIO OF FISCAL YEAR GDP TO THE ECONOMY-WIDE HOURS WORKED IN THAT YEAR ($) AND IS CALCULATED AS RGDP/HOURS. It is $ per hour
* RGDP IS REAL GDP IN $ MILLION in 2011-12 prices
* HOURS_INDEX IS AN INDEX OF HOURS WORKED IN ALL SECTORS (FROM ABS NATIONAL ACCOUNTS CAT.NO. 5204.0) WITH JUNE 2012 = 100.0
* POP IS IN PERSONS (MILLIONS)
* GDPCAP IS IN $ PER PERSON PER YEAR 2011-12 prices
* K is the capital stock ($ million) 2011-12 prices
* GFCE is investment (gross fixed capital formation) ($ million)  2011-12 prices


*******************************************************************************************************************************************
*                                                                                                                                         *
*             [3]  HOURS recalibration and changes to AVHRS                                                                               *
*                                                                                                                                         *
*                 For long-run analysis, get time series of hours that are consistent with the historical National Accounts data          *
*                 (Note that the NAC does not quite match the Labour Force hours, but they are close and the former goes back to 1959-60) *
*                  (After 2013, the growth in hours is based on the disaggregated forecasts of PT and FT hours and PT and FT employment)  *
*      Moreover, the number of hours from the LFS used for projections is re-based to be equivalent to the new LFS estimates for 2012-13  *
*      The AVHRS measures on which the original hours projections were calculated reflect the earlier series - which given time           *
*      were not updated to the newest LF data. So it is important to use the adjustment here to re-compute the AVHRS at                   *
*      the disaggragted level so it is consistent with the aggregate measure                                                              *
*                                                                                                                                         *
*******************************************************************************************************************************************
compute Hours2012_13 = 20331.7901289003  ;* This is from the latest LFS data released in September 2013 (from the by-industry data). We use it to re-base the estimates derived from the earlier LFS survey (by age, part-time work data)
compute adjfactor = Hours2012_13/hrs_preadj(2013:1)
set hrs = hrs_preadj*adjfactor ;* re-bases hours projections for latest data - (difference between most recent and penultimate hours)



SET HOURS_1 = 0.0
COMPUTE HOURS_1(2013:1) = HRS(2013:1)
DO T= 2012:1,1975:1,-1
	COMPUTE HOURS_1(T) = HOURS_1(T+1)*HOURS_INDEX(T)/HOURS_INDEX(T+1)     ;* THIS ENSURES THAT THE MEASURE OF HOURS DEVELOPED IN OUR MODEL FOLLOWS THE HISTORICAL PATTERN FROM THE LABOUR FORCE DATA
END DO T
SET HOURS = %IF(t<=2013:1.and.T>=1975:1,HOURS_1,HRS)

*print 2008:1 2060:1 hours

SET HRSPT = 0.0
SET HRSFT = 0.0

DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
      SET %S('FAVHRSPT'+SEX+AGE) = %S('FAVHRSPT'+SEX+AGE)*adjfactor
		SET %S('FAVHRSfT'+SEX+AGE) = %S('FAVHRSFT'+SEX+AGE)*adjfactor
      SET %S('HRSPT'+SEX+AGE) = %S('FAVHRSPT'+SEX+AGE)*%S('PTEMP'+SEX+AGE)*52.0
		SET %S('HRSFT'+SEX+AGE) = %S('FAVHRSFT'+SEX+AGE)*%S('FTEMP'+SEX+AGE)*52.0
      SET %S('HRS'+SEX+AGE) = %S('HRSPT'+SEX+AGE)+%S('HRSFT'+SEX+AGE)
      SET HRSPT = HRSPT+%S('HRSPT'+SEX+AGE)
      SET HRSFT = HRSFT+%S('HRSFT'+SEX+AGE)
		SET %S('HRS'+SEX+AGE) = %S('HRSPT'+SEX+AGE)+%S('HRSFT'+SEX+AGE)
  END DOFOR SEX
END DOFOR AGE



set PTAVHRS = HRSPT/PTEMP
SET FTAVHRS = HRSFT/FTEMP
*disp ptavhrs(2013:1)/52 ptavhrs(2060:1)/52
*disp ftavhrs(2013:1)/52 ftavhrs(2060:1)/52
*disp avhrs(2013:1)/52 avhrs(2060:1)/52


*DISP 1./52.0*HRSPT(2060:1)/PTEMP(2060:1) 1./52.0*HRSPT(2013:1)/PTEMP(2013:1)
*DISP 1./52.0*HRSFT(2060:1)/FTEMP(2060:1) 1./52.0*HRSFT(2013:1)/FTEMP(2013:1)
*DISP 1./52.0*HRS(2060:1)/EMP(2060:1) 1./52.0*HRS(2013:1)/EMP(2013:1)
*DISP CPOP(2013:1) POP(2013:1) LF(2013:1) EMP(2013:1) PTEMP(2013:1) FTEMP(2013:1) HRS(2013:1)
*DISP  CPOP(2060:1) POP(2060:1) LF(2060:1) EMP(2060:1) PTEMP(2060:1) FTEMP(2060:1) HRS(2060:1)
*disp cpop(2013:1)/pop(2013:1) cpop(2060:1)/pop(2060:1)
*disp hrs(2060:1)/hrs(2013:1)

SET CPOP1564_SHARE = CPOP1564/MPOP
SET CPOP1559_SHARE = CPOP1559/MPOP

* copy FORECAST data to output files
open copy "OUTPUT - ADJUSTED AVERAGE HOURS WORKED 1959-60 to 2059-60.xls"
copy(dates,format=xls,org=ROWS) 1979:1 2060:1 $
FAVHRSPTf1519 FAVHRSPTf2024 FAVHRSPTf2529 FAVHRSPTf3034 FAVHRSPTf3539 FAVHRSPTf4044 FAVHRSPTf4549 FAVHRSPTf5054 FAVHRSPTf5559 FAVHRSPTf6064 FAVHRSPTf6569 FAVHRSPTf70 $
FAVHRSPTM1519 FAVHRSPTM2024 FAVHRSPTM2529 FAVHRSPTM3034 FAVHRSPTM3539 FAVHRSPTM4044 FAVHRSPTM4549 FAVHRSPTM5054 FAVHRSPTM5559 FAVHRSPTM6064 FAVHRSPTM6569 FAVHRSPTM70 $
FAVHRSFTF1519 FAVHRSFTF2024 FAVHRSFTF2529 FAVHRSFTF3034 FAVHRSFTF3539 FAVHRSFTF4044 FAVHRSFTF4549 FAVHRSFTF5054 FAVHRSFTF5559 FAVHRSFTF6064 FAVHRSFTF6569 FAVHRSFTF70 $
FAVHRSFTM1519 FAVHRSFTM2024 FAVHRSFTM2529 FAVHRSFTM3034 FAVHRSFTM3539 FAVHRSFTM4044 FAVHRSFTM4549 FAVHRSFTM5054 FAVHRSFTM5559 FAVHRSFTM6064 FAVHRSFTM6569 FAVHRSFTM70




*************************************************************************************************
*                                                                                               *
*                  [4] BASE CASE GDP ESTIMATES for 3Ps estimates                                *
*                                                                                               *
**************************************************************************************************
* Key base case assumptions for modeling
compute mfpgrowth = 0.007
SET GROWTH = LPG_base_case   ;* DEFAULT LABOUR PRODUCTIVITY GROWTH RATES FROM 2011-12 TO 2059-60
COMPUTE DEPRATE = 0.055  ;* THE RATIO OF CONSUMTPION OF FIXED CAPITAL TO THE LAGGED NET CAPITAL STOCK IN 2011-12  when the age distribution of the capital stock is stable.
* The ratio was 0.0535 in 2012-13, higher than the historical average, but there is uncertainty about vintage effects and the structure of the capital stock structure (eg a major shift to short lived assets during the ICT revolution).
* For example, communications and IT capital has higher depreciation rates. We have used 0.055, which is on trend.
COMPUTE CAPSHARE = 0.45 ;* THE MMRF model database uses 0.4 for capshare. The ABS produces no economy-wide share, but find it is an average of 0.42 from 1973-74 to 2011-12for the market sector from 1973-74 (2012 MFP ESTIMATES BY INDUSTRY).
* The Input-output tables for 2005-06 have 0.46, but conceptually this varies from the desired measure. The last decade of data from the ABS has the figure at 0.457, and given that the early data now seems unrepresentative,
*While the last few years are corrupted by the mining boom (Parham), the rounded value of the 10 year average looks an appealing compromise.





*CREATE the basic building blocks
SET PR = LF/CPOP
SET EMPRATE = EMP/LF
SET URATE = 1.-EMPRATE
SET AVHRS = HOURS/EMP ;* PER YEAR
SET CPOPSH = CPOP/MPOP
SET KL = K/HOURS
SET ERATE = EMP/MPOP
SET POTENTIALWK = MAPWRK/MPOP
SET UNEMP = URATE*LF
SET HRSCAP = HOURS/MPOP

*disp avhrs(2013:1) avhrs(2060:1)
*DISP PTAVHRS(2013:1) PTAVHRS(2060:1)
*DISP FTAVHRS(2013:1) FTAVHRS(2060:1)
*disp hours(2013:1)/mpop(2013:1)
*disp hours(2060:1)/mpop(2060:1)
*disp hours(2013:1)



COMPUTE BASE_PROD = RGDP(2013:1)/HOURS(2013:1) ;* NOTE PRODUCTIVITY IS FOR ALL GDP NOT JUST MARKET SECTOR and is in $ per hour
SET(FIRST=BASE_PROD) PRODUCTIVITY 2013:1 2060:1 = (1.+GROWTH(T))*PRODUCTIVITY(T-1)

SET GDP_CAPITA = LF/CPOP*EMP/LF*HOURS/EMP*CPOP/MPOP*PRODUCTIVITY
SET GDP = HOURS*PRODUCTIVITY
compute GDP_Growth = (gdp(2060:1)/gdp(2013:1) )^(1./(2060:1-2013:1)) -1.
*NOTE THAT GDP_CAPITA*MPOP IN 2012-13 EQUALS THE NATIONAL ACCOUNTS GDP, BUT THE PER CAPITA FIGURE DIFFERS BECAUSE OF POPULATION DIFFERENCES
*the National Accounts (NAC) measure of GDP per capita uses a population estimate that is slightly different
*DISP GDP_CAPITA(2013:1) GDPCAP(2013:1)
*DISP GDP_CAPITA(2013:1)*MPOP(2013:1) RGDP(2013:1)
set gdp = %if(T<2014:1,rgdp,gdp)


SET Y = 0.0          ;*THIS DEFINES A FULL TIME SERIES OF GDP PER CAPITA  FROM 1959-60 TO 2059-60 and productivity from 1974-75 to 2059-60
SET Y 2013:1 2060:1 = GDP_CAPITA
SET PROD = 0.0
SET PROD 2013:1 2060:1 = PRODUCTIVITY
DO TIME = 2012:1,1960:1,-1
	COMPUTE Y(TIME) = Y(TIME+1)*GDPCAP(TIME)/GDPCAP(TIME+1)
	COMPUTE PROD(TIME) = PROD(TIME+1)*GDPHOUR_INDEX(TIME)/GDPHOUR_INDEX(TIME+1)
END DO TIME
set gdp_capita = %if(t<2013:1,y,gdp_capita)

*disp GDP(2013:1) hours(2013:1) prod(2013:1) GDP(2013:1)/hours(2013:1)



* copy FORECAST data to output file just on productivity, gdp and gdp per capita (all in 2011-12 prices)
open copy "OUTPUT GDP and productivity data 1974-75 to 2059-60.xls"
copy(dates,format=xls,org=columns) 1975:1 2060:1 GDP GDP_capita prod




COMPUTE PER = 2013:1
DISP '___________________________________________________________________ '
DISP 'BUILDING BLOCKS IN 2012-13 in 2011-12 prices'
DISP '___________________________________________________________________ '
DISP 'GDP ($ MILLION) = ' *. GDP(PER)
DISP 'MA of POP (MILLION) = ' MPOP(PER)
DISP 'LF (MILLION)=' LF(PER)
DISP 'CPOP (MILLION)= ' CPOP(PER)
DISP 'PR = ' PR(PER)
DISP 'EMP (MILLION)= ' EMP(PER)
DISP 'EMPRATE = ' EMPRATE(PER)
DISP 'HOURS (MILLION)= ' HOURS(PER)
DISP 'AVHRS (PER YEAR PER EMPLOYEE)= ' AVHRS(PER)
DISP 'CPOPSH = ' CPOPSH(PER)
DISP 'PRODUCTIVITY LEVEL ($ per hour) = ' PRODUCTIVITY(PER)
DISP 'BUILDING BLOCK GDP ($m) = ' *. MPOP(PER)*PR(PER)*EMPRATE(PER)*AVHRS(PER)*CPOPSH(PER)*PRODUCTIVITY(PER)
DISP '___________________________________________________________________ '



*******************************************************************************
*
*                          [9] CAPITAL MEASURES
*
*******************************************************************************


set dlogK 2014:1 2060:1 = 1./capshare*(log(Growth+1.)-mfpgrowth)+log(Hours(t)/Hours(t-1));* ACTUAL YEAR BY YEAR IMPLIED NET CAPITAL STOCK GROWTH
SET(FIRST=K(2013:1)) NETK 2013:1 2060:1 = exp(dlogk)*NETK(T-1)  ;*capital stock estimate
SET NETK = %IF(t<2014:1,K,NETK)
set logk = log(netk)
set logL = log(hours)
set logKL = log(netk/hours)
set dlogL = log(Hours(t)/Hours(t-1))
set logYK = log(gdp/netk)
set lproductivity = log(productivity)






compute CHL = (HOURS(2060:1)/hOURS(2013:1) )^(1./(2060:1-2013:1)) -1.
compute CHK = (NETK(2060:1)/NETK(2013:1) )^(1./(2060:1-2013:1)) -1.
*disp chk chl
linreg(noprint) logkl 2013:1 2060:1
# constant trend
compute kl_trendg = %beta(2)
linreg(noprint) logYK 2013:1 2060:1
# constant trend
compute yk_trendg = %beta(2)
linreg(noprint) logL 2013:1 2060:1
# constant trend
compute L_trendg = %beta(2)
linreg(noprint) logk 2013:1 2060:1
# constant trend
compute k_trendg = %beta(2)
linreg(noprint) lproductivity 2013:1 2060:1
# constant trend
compute lp_trendg = %beta(2)





SET INVEST = %if(T<=2013:1,GFCE,NETK-NETK(T-1)*(1.-DEPRATE))
SET DEPRECIATION = DEPRATE*netk(t-1)
COMPUTE STARTdate = 2014:1
COMPUTE ENDdate = 2060:1
compute Sum_Invest2 = 0.0
DO T = STARTdate, ENDdate
	compute Sum_Invest2 = Sum_Invest2 + Invest(t)
end do t

compute sum_invest1 = 0.0
DO T = 1960:1, 2013:1
	compute sum_invest1 = sum_invest1 + gfce(t)
end do t

disp 'Total investment required in real terms from 1959-60 to 2012-13 in $ trillion 2011-12 prices is '  *.* sum_invest1/1000000.
disp 'Total investment required in real terms from 2013-14 to 2059-60 in $ trillion 2011-12 prices is '  *.* sum_invest2/1000000.


set invest_gdp = invest/gdp
*graph 1
*# invest_gdp



*
*
*                          [9] RNNDI (2011-12 prices)
*
*******************************************************************************
set exports = export_share/100.*gdp
set TTeffect = termsTrade*exports
set rnost = rnost_share/100.*gdp


set rnndi = %if(T<=2013:1,rnndi,gdp+tteffect+rnost-depreciation)
set rnndi_gdp = rnndi/gdp
set rnndi_capita = rnndi/mpop

*disp tteffect(2013:1)




***************************************************************************
*                                                                         *
*                  [7] PARTICIPATION RATE IF NO AGEING HAD OCCURRED       *
*                                                                         *
***************************************************************************

SET XXCPOP = 0.0
SET XHRS = 0.0
SET XEMP = 0.0
SET XCPOP = CPOP(2013:1)/MPOP(2013:1)*MPOP
SET XLF = 0.0
SET XPTEMP = 0.0
SET XFTEMP = 0.0
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
     	SET %S('XCPOP'+SEX+AGE) = %S('FCPOP_RATIO'+SEX+AGE)*(%S('FMAPOP'+SEX+AGE)(2013:1))/MPOP(2013:1)*MPOP/1000000. ;*CIVILIAN POP IN MILLION BY AGE AND SEX IF NO CHANGE IN CPOP RATIO AGE STRUCTURE
      SET %S('XLF'+SEX+AGE) = %S('FPR'+SEX+AGE)*%S('XCPOP'+SEX+AGE) ;*LABOUR FORCE BY AGE AND SEX WITH NO CHANGE IN AGE STRUCTURE
      SET XLF = XLF+%S('XLF'+SEX+AGE)
      SET %S('XEMP'+SEX+AGE) = %S('FEMPRATE'+SEX+AGE)*%S('XLF'+SEX+AGE)
      SET XEMP = XEMP+%S('XEMP'+SEX+AGE)
      SET %S('XPTEMP'+SEX+AGE) = %S('FPTSH'+SEX+AGE)*%S('XEMP'+SEX+AGE)
      SET XPTEMP = %S('XPTEMP'+SEX+AGE)+XPTEMP
      SET %S('XFTEMP'+SEX+AGE) = %S('XEMP'+SEX+AGE)-%S('XPTEMP'+SEX+AGE)
      SET %S('XHRS'+SEX+AGE) = %S('FAVHRSPT'+SEX+AGE)*%S('XPTEMP'+SEX+AGE)*52.0+%S('FAVHRSFT'+SEX+AGE)*%S('XFTEMP'+SEX+AGE)*52.0
      SET XHRS = XHRS+%S('XHRS'+SEX+AGE)
  END DOFOR SEX
END DOFOR AGE
SET XPR = XLF/XCPOP
SET XPRR = XLF/XCPOP*100.

*___________________________________________________________________
*
*
*
*                          [9] Scenarios for productivity growth
*
*******************************************************************************
set Growth_S1 = %if(t==2013:1,Growth,Growth+0.003)
set Growth_S2 = %if(t==2013:1,Growth,Growth-0.003)


SET(FIRST=BASE_PROD) PRODUCTIVITY_s1 2013:1 2060:1 = (1.+GROWTH_S1(T))*PRODUCTIVITY_s1(T-1)
SET GDP_CAPITA_s1 = LF/CPOP*EMP/LF*HOURS/EMP*CPOP/MPOP*PRODUCTIVITY_s1
SET GDP_s1 = HOURS*PRODUCTIVITY_s1
compute GDP_Growth_s1 = (gdp_s1(2060:1)/gdp_s1(2013:1) )^(1./(2060:1-2013:1)) -1.

SET(FIRST=BASE_PROD) PRODUCTIVITY_s2 2013:1 2060:1 = (1.+GROWTH_S2(T))*PRODUCTIVITY_s2(T-1)
SET GDP_CAPITA_s2 = LF/CPOP*EMP/LF*HOURS/EMP*CPOP/MPOP*PRODUCTIVITY_s2
SET GDP_s2 = HOURS*PRODUCTIVITY_s2
compute GDP_Growth_s2 = (gdp_s2(2060:1)/gdp_s2(2013:1) )^(1./(2060:1-2013:1)) -1.

SET PROJZONE = T>=2013:1
grparm vlabel 20 keylabeling 18 axislabelling 20 subheader 20
graph(patterns,SHADING=PROJZONE,VLABEL="GDP per capita (%)") 3
# gdp_capita 1975:1 2060:1 11
# gdp_capita_s1 1975:1 2060:1 2
# gdp_capita_s2 1975:1 2060:1 2

*SET PROJZONE = T>=2013:1
*grparm vlabel 20 keylabeling 18 axislabelling 20 subheader 20
*graph(patterns,SHADING=PROJZONE,VLABEL="GDP per capita (%)", key=attached,$
*klabels=||"Base case", "Base case+0.3 percentage points","Base case-0.3 percentage points"||) 3
*# gdp_capita 1975:1 2060:1 11
*# gdp_capita_s1 1975:1 2060:1 2
*# gdp_capita_s2 1975:1 2060:1 2


COMPUTE [INTEGER] END = 2060:1
COMPUTE START = 2014:1
compute BASE_INCOME = 0.0
compute INCOME_s1 = 0.0
compute INCOME_s2 = 0.0
do t = START, END
   compute BASE_INCOME=BASE_INCOME+GDP(t)         ;*BASE GDP in $ received over the period from 2012-13 to 2059-60
   compute INCOME_S1=INCOME_s1+ GDP_s1(t)          ;*ALTERNATIVE GDP in $ received over the period from 2012-13 to 2059-60  WITH DIFFERENT PRODUCTIVITY RATE
   compute INCOME_S2=INCOME_s2+ GDP_s2(t)          ;*ALTERNATIVE GDP in $ received over the period from 2012-13 to 2059-60  WITH DIFFERENT PRODUCTIVITY RATE
end do t

statistics(noprint) mpop START END   ;* population  (no.)
COMPUTE MEANPOP = %MEAN



disp '__________________________________________________________________________________'
disp 'The effects of different productivity growth rates on accumulated income $ trillion'
DISP @10 'Base case' @40 'Better productivity' @60 'wORSE productivity'
disp base_income/1000000. income_s1/1000000. income_s2/1000000.
disp '__________________________________________________________________________________'
disp @1 'Base growth 2012-13 to 2059_60' (gdp(2060:1)/gdp(2013:1)-1.)*100
disp @1 'Better 2012-13 to 2059_60' (gdp_s1(2060:1)/gdp_s1(2013:1)-1.)*100
disp @1 'Worse 2012-13 to 2059_60' (gdp_s2(2060:1)/gdp_s2(2013:1)-1.)*100
disp '__________________________________________________________________________________'
disp @1 'Av per capita GDP 2012-13 to 2059-60' *.  base_income/meanpop  *.  income_s1/meanpop *.  income_s2/meanpop
disp @1 'Productivity dividend per capita fom good outcome'  *.  income_s1/meanpop-base_income/meanpop
disp @1 'Productivity dividend per capita fom bad outcome'  *.  income_s2/meanpop-base_income/meanpop
disp '__________________________________________________________________________________'
disp 'lost income from lower productivity growth = ' (1/1000000.)*(base_income-income_s2)
disp 'Increased income from lower productivity growth = ' (1/1000000.)*(income_s1-base_income)




*_______________________________________________________________

*           BOOTSTRAP ESTIMATES
*
*_______________________________________________________________

OPEN DATA "INPUT peak to peak labour productivity estimates.xls"
DATA(FORMAT=XLS,ORG=ROWS) 1 12 peakLP
SET PEAKLP 1 12 = PEAKLP/100.0
stats(NOprint) PEAKLP 1 12
COMPUTE AVLR = %MEAN  ;* ARITHMETIC AVERAGE OF PEAK TO PEAK LP GROWTH RATES

compute ndraws = 10000
smpl 13 24
dec vect PRODSIMS(ndraws)
dec vect INCSIMS(ndraws)
dec vect GROWTHSIMS(ndraws)
COMPUTE END = 2060:1
COMPUTE START = 2014:1

do draws = 1,ndraws
boot entries / 1 12

	set path = peakLP(entries)
	stats(noprint) path
	COMPUTE DEV = %mean/AVLR
	set Growth_S3 2013:1 2060:1 = %if(t==2013:1,Growth,GROWTH*DEV)  ;*CALCULATION IS TO ADD HISTORICAL DEVIATION FROM AVLR TO FUTURE PROEJCTED BASECASE PATH OF LP
	stats(noprint) GROWTH_S3 2013:1 2060:1
   compute PRODsims(draws) = 100*%mean
	SET(FIRST=BASE_PROD) PRODUCTIVITY_s3 2013:1 2060:1 = (1.+GROWTH_S3(T))*PRODUCTIVITY_s3(T-1)
	SET GDP_CAPITA_s3 2013:1 2060:1 = LF/CPOP*EMP/LF*HOURS/EMP*CPOP/MPOP*PRODUCTIVITY_s3
	SET GDP_s3 2013:1 2060:1 = HOURS*PRODUCTIVITY_s3
	compute GROWTHSIMS(DRAWS) = ((GDP_CAPITA_s3(2060:1)/GDP_CAPITA_s3(2013:1) )^(1./(2060:1-2013:1)) -1.)*100.
	compute INCOME_s3 = 0.0
		do t = START, END
   	compute INCOME_S3 = INCOME_s3+ GDP_s3(t)
	end do t
	compute INCSIMS(DRAWS) = 1./MEANPOP*income_s3
end do draws


compute ratefract = %fractiles(PRODSIMS,||0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9||)
disp "10% to 90% fractiles of mean peak to peak productivity growth ARE" $
##.## ratefract(1) ratefract(2) ratefract(3)  ratefract(4) ratefract(5)  ratefract(6) ratefract(7)  ratefract(8) ratefract(9)

compute ratefract2 = %fractiles(GROWTHSIMS,||0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9||)
disp "10% to 90% fractiles of PER CAPITA GROWTH RATES" $
##.## ratefract2(1) ratefract2(2) ratefract2(3)  ratefract2(4) ratefract2(5)  ratefract2(6) ratefract2(7)  ratefract2(8) ratefract2(9)

compute ratefract3 = %fractiles(INCSIMS,||0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9||)
compute med = ratefract3(5)
disp "10% to 90% fractiles of AVERAGE INCOME BENEFITS cf median" $
*. ratefract3(1)-med ratefract3(2)-med ratefract3(3)-med  ratefract3(4)-med ratefract3(5)-med  ratefract3(6)-med ratefract3(7)-med  ratefract3(8)-med ratefract3(9)-med





********************************************************************************
*                                                                              *
*                         [10] WRITE KEY UNDERLYING DATA TO FILES                *
*                                                                              *
*                                                                              *
********************************************************************************
* copy FORECAST data to output files



* copy data to an output file
dedit(new) "OUTPUT GDP and other key data 1959-60 to 2059-60.rat"
store lf pr xpr emp cpop mpop avhrs hours emprate gdp gdp_capita invest netk ptsh cpopsh hrscap depreciation rnndi rnost exports tteffect $
gdp_s1 gdp_s2 gdp_capita_s1 gdp_capita_s2 growth growth_s1 growth_s2 CPOP1564_SHARE

SAVE


* copy FORECAST data to output files
open copy "OUTPUT GDP and other key data 1959-60 to 2059-60.xls"
copy(dates,format=xls,org=columns) 1960:1 2060:1 $
lf pr xpr emp cpop mpop avhrs hours emprate gdp gdp_capita invest netk ptsh cpopsh hrscap depreciation rnndi rnost exports tteffect $
gdp_s1 gdp_s2 gdp_capita_s1 gdp_capita_s2 growth growth_s1 growth_s2 CPOP1564_SHARE CPOP1559_SHARE


********************************************************************************
*                                                                              *
*                         [11] GDP IF PRODUCTIVITY VARIES BY AGE                *
*                                                                              *
********************************************************************************

* THESE ARE PRODUCTIVITY RELATIVITIES implied by the wage profile

SET PRODM1519 = 0.65408
sET PRODM2024 = 0.77248
SET PRODM2529 = 0.867
SET PRODM3034 = 0.937
SET PRODM3539 = 0.984
SET PRODM4044 = 1.006
SET PRODM4549 = 1.0044
SET PRODM5054 = 0.979
SET PRODM5559 = 0.929
SET PRODM6064 = 0.856
SET PRODM6569 = 0.758
SET PRODM70 = 0.688

SET PRODF1519 = 0.576
SET PRODF2024 = 0.68
SET PRODF2529 = 0.763
SET PRODF3034 = 0.825
SET PRODF3539 = 0.866
SET PRODF4044 = 0.885
SET PRODF4549 = 0.884
SET PRODF5054 = 0.861
SET PRODF5559 = 0.818
SET PRODF6064 = 0.753
SET PRODF6569 = 0.667
SET PRODF70 = 0.605

*DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
*  DOFOR SEX = 'M' 'F'
*      SET %S('PROD'+SEX+AGE) = 1.00      ;* JUST A CHECK TO SEE THAT WE GET THE BASECASE WITH ALL REL PROD RATES =1.0
*  END DOFOR SEX
*END DOFOR AGE

SET OUTPUT = 0.0
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
      SET %s('Ybit'+sex+age) = 0.0
      SET %s('Ybit'+sex+age) = %S('HRS'+SEX+AGE)*BASE_PROD*%S('PROD'+SEX+AGE)*(1+growth)^(t-2013:1) ;* This is the GDP contribution by each age/sex group (from 2012-13 and in $m)
 		set output = output+%s('Ybit'+sex+age)
  END DOFOR SEX
end dofor age




COMPUTE ADJ_SCALE = GDP(2013:1)/OUTPUT(2013:1)  ;* Adjusts the OUTPUT because the various productivity relativeities do not lead to exact GDP



DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
      SET %S('APROD'+SEX+AGE) = 0.0
      SET %S('APROD'+SEX+AGE) = ADJ_SCALE*%S('PROD'+SEX+AGE)
      DISP SEX AGE %S('APROD'+SEX+AGE)(2013:1)
  END DOFOR SEX
end dofor age



disp (gdp(2060:1)/gdp(2013:1)-1.)*100
SET OUTPUT = ADJ_SCALE*OUTPUT
SET AGEPROD = ((OUTPUT/GDP)-1)*100.
print 2013:1 2060:1 AGEPROD
COMPUTE START = 2013:1
COMPUTE END = 2060:1
COMPUTE SUMGDP_BASE = 0.0
COMPUTE SUM_AGEVARYING = 0.0
compute DISCOUNT_RATE = 0.08
do t = START, END
   compute SUMGDP_BASE = SUMGDP_BASE+GDP(t)/((1+DISCOUNT_RATE)^(T-START))            ;*PV OF SUMGDP_BASE in $ received over the period from 2011-12 to 2059-60
   compute SUM_AGEVARYING = SUM_AGEVARYING+OUTPUT(t)/((1+DISCOUNT_RATE)^(T-START))   ;*PV OF SUM_AGEVARYING GDP in $ received over the period from 2011-12 to 2059-60  WITH AGE-VARYING PRODUCTIVITY RATES
end do t

DISP 'PV of the base case sum of output from 2011-12 to 2059-60) is ($billion)' SUMGDP_BASE/1000.
DISP 'PV of the alternative age-varying productivity case from 2011-12 to 2059-60) is ($billion)' SUM_AGEVARYING/1000.
Disp '% of Effect of time-varying rates on output is (%) (a negative number means a loss from varying rates) ' ((SUM_AGEVARYING/SUMGDP_BASE)-1.)*100.



***************************************************************************
*                                                                         *
*   [6] Calculate male and female labour supply aggregates separately     *
                                                                          *
*                                                                        *
***************************************************************************
* Calculate male and female labour supply aggregates separately
     	SET MAPWRKM = 0.0
     	SET MAPWRKF = 0.0
      SET CPOPM = 0.0
      SET CPOPF = 0.0
      SET LFF = 0.0
      SET LFM = 0.0
      SET EMPM = 0.0
      SET EMPF = 0.0
      SET PTEMPM = 0.0
      SET PTEMPF = 0.0
      SET FTEMPM = 0.0
      SET FTEMPF = 0.0
      SET HRSM = 0.0
      SET HRSF = 0.0
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
     	SET MAPWRKM = %S('FMAPOPM'+AGE)/1000000.+MAPWRKM   ;*MAPWRK IS THE 2 YR MOVING AVERAGE OF THE POTENTIAL WORKFORCE INCLUDING 70+
     	SET MAPWRKF = %S('FMAPOPF'+AGE)/1000000.+MAPWRKF
      SET CPOPM = CPOPM+%S('CPOPM'+AGE)
      SET CPOPF = CPOPF+%S('CPOPF'+AGE)
      SET LFF = LFF+%S('LFF'+AGE)
      SET LFM = LFM+%S('LFM'+AGE)
      SET EMPM = EMPM+%S('EMPM'+AGE)
      SET EMPF = EMPF+%S('EMPF'+AGE)
      SET PTEMPM = %S('PTEMPM'+AGE)+PTEMPM
      SET PTEMPF = %S('PTEMPF'+AGE)+PTEMPF
      SET FTEMPM = EMPM-PTEMPM
      SET FTEMPF = EMPF-PTEMPF
      SET HRSM = HRSM+%S('HRSM'+AGE)
      SET HRSF = HRSF+%S('HRSF'+AGE)
END DOFOR AGE

set ptshm = ptempm/empm
set ptshf = ptempf/empf
SET PRF = LFF/CPOPF
SET PRM = LFM/CPOPM


*disp ptshm(2013:1) ptshm(2060:1)
*disp ptshf(2013:1) ptshf(2060:1)
*disp ptsh(2013:1) ptsh(2060:1)
*disp cpop(2013:1) cpopf(2013:1) cpopm(2013:1)

*DISP 'Female contribution to civilian pop growth 2012-13 to 2059-60 = ' 100.0*(CPOPF(2060:1)-CPOPF(2013:1))/(CPOP(2060:1)-CPOP(2013:1))
*DISP 'Female contribution to civilian pop growth 1978-79 to 2012-13 = ' 100.0*(CPOPF(2013:1)-CPOPF(1979:1))/(CPOP(2013:1)-CPOP(1979:1))
*DISP 'Female contribution to LF growth 2012-13 to 2059-60 = ' 100.0*(LFF(2060:1)-LFF(2013:1))/(LF(2060:1)-LF(2013:1))
*DISP 'Female contribution to LF growth 1978-79 to 2012-13 = ' 100.0*(LFF(2013:1)-LFF(1979:1))/(LF(2013:1)-LF(1979:1))
*DISP 'Female contribution to hours growth 2012-13 to 2059-60 = ' 100.0*(HRSf(2060:1)-HRSF(2013:1))/(HRS(2060:1)-HRS(2013:1))
*DISP 'Female contribution to hours growth 1978-79 to 2012-13 = ' 100.0*(HRSF(2013:1)-HRSF(1979:1))/(HRS(2013:1)-HRS(1979:1))
*DISP 'Female contribution to employment growth 2012-13 to 2059-60 = ' 100.0*(EMPf(2060:1)-EMPF(2013:1))/(EMP(2060:1)-EMP(2013:1))
*DISP 'Female contribution to employment growth 1978-79 to 2012-13 = ' 100.0*(EMPF(2013:1)-EMPF(1979:1))/(EMP(2013:1)-EMP(1979:1))
*DISP 'Female contribution to full-time employment growth 2012-13 to 2059-60 = ' 100.0*(FTEMPf(2060:1)-FTEMPF(2013:1))/(FTEMP(2060:1)-FTEMP(2013:1))
*DISP 'Female contribution to full-time employment growth 1978-79 to 2012-13 = ' 100.0*(FTEMPF(2013:1)-FTEMPF(1979:1))/(FTEMP(2013:1)-FTEMP(1979:1))
*DISP 'Female contribution to PART-time employment growth 2012-13 to 2059-60 = ' 100.0*(PTEMPf(2060:1)-PTEMPF(2013:1))/(PTEMP(2060:1)-PTEMP(2013:1))
*DISP 'Female contribution to PART-time employment growth 1978-79 to 2012-13 = ' 100.0*(PTEMPF(2013:1)-PTEMPF(1979:1))/(PTEMP(2013:1)-PTEMP(1979:1))
*disp ptempf(2013:1)/empf(2013:1) ptempf(2060:1)/empf(2060:1)
*


set prm2554 = (lfm2529+lfm3034+lfm3539+lfm4044+lfm4549+lfm5054)/(CPOPM2529+CPOPM3034+CPOPM3539+CPOPM4044+CPOPM4549+CPOPM5054)
set prF2554 = (lfF2529+lfF3034+lfF3539+lfF4044+lfF4549+lfF5054)/(CPOPF2529+CPOPF3034+CPOPF3539+CPOPF4044+CPOPF4549+CPOPF5054)

*graph 4
*# fprf5559 2006:1 2013:1
*# fprf6064 2006:1 2013:1
*# fprf6569 2006:1 2013:1
*# fprf70 2006:1 2013:1

*disp fprf6064(2013:1) fprf6569(2013:1) fprm6064(2013:1) fprm6569(2013:1)
*disp fprf6064(2060:1) fprf6569(2060:1) fprm6064(2060:1) fprm6569(2060:1)


***************************************************************************
*                                                                         *
*                  [6] SELECTED GRAPHS of participation                                    *
*                                                                         *
***************************************************************************
set lfg 1980:1 2013:1 = (lf(t)/lf(t-1)-1.)*100
STATS(noprint) LFG 1980:01 2013:01
set firstp 1980:1 2013:1 = %MEAN
set lfg2 2014:1 2060:1 = (lf(t)/lf(t-1)-1.)*100
STATS(noprint) LFG2 2014:01 2060:01
set SECONDP 2014:1 2060:1 = %MEAN
SET PROJZONE = T>=2013:1
set prR = pr*100.0




grparm vlabel 20 keylabeling 18 axislabelling 20 subheader 20

graph(patterns,SHADING=PROJZONE,VLABEL="Growth in labour force (%)",key=attached,$
klabels=||"Growth pre 2012-13","Growth post 2012-13","Average","Average"||) 4
# lfg 1980:1 2013:1  11
# lfg2 2013:1 2060:1  1
# FIRSTP 1980:1 2013:1  2
# SECONDP 2013:1 2060:1 2

*graph 1
*# cpopsh







grparm vlabel 20 keylabeling 18
graph(patterns,SHADING=PROJZONE,VLABEL="Participation rate (%)",key=attached,$
klabels=||"Pre 2011-12","Post 2011-12 with ageing","No ageing"||) 3
# prr 1979:1 2013:1  11
# prr 2013:1 2060:1  1
# XPRR 2013:1 2060:1 12



*GRAPH 1
*# HRSCAP 1979:1 2060:1
*GRAPH 1
*# AVHRS 1979:1 2060:1
*GRAPH 1
*# emprate 1979:1 2060:1
*GRAPH 1
*# pr 1979:1 2060:1

*disp pr(2013:1)*emprate(2013:1)*avhrs(2013:1)*cpopsh(2013:1) hrscap(2013:1)
*disp pr(2060:1)*emprate(2060:1)*avhrs(2060:1)*cpopsh(2060:1) hrscap(2060:1)
*disp log(pr(2060:1)/pr(2013:1)) log(emprate(2060:1)/emprate(2013:1)) log(avhrs(2060:1)/avhrs(2013:1)) log(cpopsh(2060:1)/cpopsh(2013:1)) log(hrscap(2060:1)/hrscap(2013:1))

***************************************************************************
*                                                                         *
*    [8] Labour supply implications of OECD 80th percentile for women     *
*                                                                         *
***************************************************************************
*FIRST SET OECD 80TH PERCENTILE PARTICIPATION RATES FOR WOMEN (OR SUBSTITUTE VALUES WHERE RELEVANT)
SET OECDF1519 = FPRF1519  ;* ACTUAL AUSTRALIAN NUMBERS SINCE THE oecd 80TH PERCENTILE IS LESS THAN THE AUSTRALIAN FIGURE
SET OECDF2024 = FPRF2024 ;* AS ABOVE
SET OECDF70 = FPRF70 ;* VERY LITTLE INFORMATION FROM OECD DATBASE AND SO THE SCENARIO HOLDS THE VALUE FIXED AT THE AUSTRALIAN LEVEL
set oecdf2529 = .823
set oecdf3034 = .855
set oecdf3539 = .849
set oecdf4044 = .875
set oecdf4549 = .885
set oecdf5054 = .838
set oecdf5559 = .767
set oecdf6064 = .493
set oecdf6569 = .259

set oecdlfF = 0.0
set oecdempF = 0.0
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'F'
      SET %S('oecdLF'+SEX+AGE) = %S('oecd'+SEX+AGE)*%S('CPOP'+SEX+AGE)   ;* this is the Australian female LF by age were the max of the Australian and OECD female participation rate to be applied
      SET oecdLFF = oecdLFF+%S('oecdLF'+SEX+AGE) ;* this is the total female labour force in Australia were the max of the Australian and OECD female participation rate to be applied
      SET %S('oecdEMP'+SEX+AGE) = %S('FEMPRATE'+SEX+AGE)*%S('oecdLF'+SEX+AGE) ;* this is Australian female employment by age were the OECD PRs to apply
      SET oecdEMPF = oecdEMPF+%S('oecdEMP'+SEX+AGE)  ;* this is total female employment using the OECD benchmark
  END DOFOR SEX
END DOFOR AGE
SET OECDPRF = OECDLFF/CPOPF ;* this is the aggregate Australian female participation rate using age-specific OECD rates as the benchmark
DISP OECDPRF(2013:1) OECDPRF(2060:1) PRF(2013:1) PRF(2060:1) ;* a comparison of the benchmark female PRs with the counterfactual for 2013 and 2060
DISP OECDEMPF(2013:1) OECDEMPF(2060:1) EMPF(2013:1) EMPF(2060:1) ;* a comparison of benchmark female employment with the counterfactual for 2013 and 2060



*****************************************************************************
*
*              summary of major contributors to growth
*
*****************************************************************************

COMPUTE START = 2013:1 ;*ALTERNATIVE IS 1980:1
COMPUTE END = 2060:1
compute header = 'Key drivers of future GDP growth'
grparm axislabelling 28 keylabelling 28 subheader 24
SPGRAPH(HFIELD=2,vfield=2) ;* include header=header if you want the header
GRAPH(subheader='Average weekly hours',nopatterns,vticks=6) 1
# AVHRS START END
GRAPH(subheader='Employment rate',nopatterns,vticks=6) 1
# EMPRATE START END
GRAPH(subheader='Participation rates',nopatterns,vticks=6) 1
# PR START END  1
GRAPH(subheader='Productivity index',nopatterns,vticks=6) 1
# PRODUCTIVITY START END
SPGRAPH(DONE)



disp '______________________________________________________________________________'
disp '% DIFFERENCE BETWEEN THE 2012 EMPRATE AND THE AVERAGE FROM 1978-79 TO 2011-12'
disp '______________________________________________________________________________'
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
		DOFOR SEX = 'F' 'M'
			STATS(noprint) %S('FEMPRATE'+SEX+AGE) 1979:01 2012:01
			DISP AGE SEX  (%MEAN/%S('FEMPRATE'+SEX+AGE)(2013:1)-1.)*100.
      END DOFOR SEX
END DOFOR AGE
disp '______________________________________________________________________________'
disp '% DIFFERENCE BETWEEN THE 2060 EMPRATE AND THE 2011-12 value'
disp '______________________________________________________________________________'
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
		DOFOR SEX = 'F' 'M'
			STATS(noprint) %S('FEMPRATE'+SEX+AGE) 1979:01 2012:01
			DISP AGE SEX 'IS ' %S('FEMPRATE'+SEX+AGE)(2060:1)-%S('FEMPRATE'+SEX+AGE)(2013:1)
      END DOFOR SEX
END DOFOR AGE




***************************************************************************************************************************************
*                                     [9] DECOMPOSITION OF GDP GROWTH IN LOG FORM *
***************************************************************************************************************************************
COMPUTE START = 2013:1
COMPUTE END = 2060:1
COMPUTE PERIOD = END-START
DISP '___________________________________________________________________________________________________'
disp 'Decomposition of real GDP growth 2012-13 TO 2059-60 average yearly trend growth'
DISP 'Change in GDP' (LOG(gdp(END))-LOG(gdp(START)))/PERIOD
DISP 'Change in POP' (LOG(mpop(END))-LOG(mpop(START)))/PERIOD
DISP 'Change in participation rate' (LOG(PR(END))-LOG(PR(START)))/PERIOD
DISP 'Change in employment rate' (LOG(EMPRATE(END))-LOG(EMPRATE(START)))/PERIOD
DISP 'Change in average hours worked' (LOG(AVHRS(END))-LOG(AVHRS(START)))/PERIOD
DISP 'Change in civilian population to population ratio' (LOG(CPOPSH(END))-LOG(CPOPSH(START)))/PERIOD
DISP 'Change in productivity (output per hour worked)' (LOG(PRODUCTIVITY(END))-LOG(PRODUCTIVITY(START)))/PERIOD
DISP 'Growth in GDP per capita' (LOG(gdp_capita(END))-LOG(gdp_capita(START)))/PERIOD
DISP 'Check OF change in GDP per capita RESULTS' (LOG(PR(END))-LOG(PR(START))+LOG(EMPRATE(END))-LOG(EMPRATE(START))+LOG(AVHRS(END))-LOG(AVHRS(START))+LOG(CPOPSH(END))-LOG(CPOPSH(START))+LOG(PRODUCTIVITY(END))-LOG(PRODUCTIVITY(START)))/PERIOD
DISP '___________________________________________________________________________________________________'
 * NOTE THE SAME DECOMPISTION FROM 1975:1 TO 2011:12   WILL NOT ADD TO THE NATIONAL ACCOUNTS GDP PER CAPITA
 * BUT IS STILL USEFUL IN TERMS OF SHARES OF THE INTERNLLY CONSISTENT TOTAL. IT DOES NOT ADD TO THE  NAC MEASURE OF GDP PER CAPITA
 * BECAUSE LF, EMP, CPOP AND POP ARE DIFERENTLY DEFINED IN THE NATIONAL ACCOUNTS
 * NOTE THAT IF Y(T) = EXP(GROWTH*T) (OR AN EXPONENTIAL GROWTH FUNCTION), THEN LOG(Y(T))- LOG(Y(0)) = GROWTH*T , WHERE GROWTH IS ANNUAL TEND RATE.
* ACCORDINGLY, 1/T * LOG(Y(T))- LOG(Y(0)) IS THE ESTIMATE OF THE ANNUAL TREND GROWTH RATE IN GDP (AND SIMILARLY SO FOR THE OTHER ITEMS IN THE DECOMPOSITION)

disp hours(2060:1)/mpop(2060:1)
disp hours(2013:1)/mpop(2013:1)
disp hours(2013:1)
  20331.79013

set Y = gdp_capita
*Average growth rates in different periods
COMPUTE START = 2013:1
COMPUTE END = 2020:1
COMPUTE PERIOD = END-START
COMPUTE PRCH = 100*((PR(END)/PR(START))^(1./PERIOD)-1.)
COMPUTE EMPCH = 100*((EMPRATE(END)/EMPRATE(START))^(1./PERIOD)-1.)
COMPUTE AVHRSCH = 100*((AVHRS(END)/AVHRS(START))^(1./PERIOD)-1.)
COMPUTE PRODCH = 100*((PRODUCtivity(END)/PRODuctivity(START))^(1./PERIOD)-1.)
COMPUTE GDPCH = 100*((Y(END)/Y(START))^(1./PERIOD)-1.)
COMPUTE CHECK = PRCH+EMPCH+PRODCH+AVHRSCH     ;*CHECK WON'T ADD TO GDPCH BUT IT SHOULD BE REASONABLY CLOSE
DISP '2011-12 TO 2019-20' PRCH EMPCH AVHRSCH  PRODCH GDPCH CHECK
DISP ' ______________________________________________________________'
COMPUTE START = 2020:1
COMPUTE END = 2030:1
COMPUTE PERIOD = END-START
COMPUTE PRCH = 100*((PR(END)/PR(START))^(1./PERIOD)-1.)
COMPUTE EMPCH = 100*((EMPRATE(END)/EMPRATE(START))^(1./PERIOD)-1.)
COMPUTE AVHRSCH = 100*((AVHRS(END)/AVHRS(START))^(1./PERIOD)-1.)
COMPUTE PRODCH = 100*((PRODUCtivity(END)/PRODUCtivity(START))^(1./PERIOD)-1.)
COMPUTE GDPCH = 100*((Y(END)/Y(START))^(1./PERIOD)-1.)
COMPUTE CHECK = PRCH+EMPCH+PRODCH+AVHRSCH
DISP '2019-20 TO 2029-30' PRCH EMPCH AVHRSCH  PRODCH GDPCH CHECK
DISP ' ______________________________________________________________'
COMPUTE START = 2030:1
COMPUTE END = 2040:1
COMPUTE PERIOD = END-START
COMPUTE PRCH = 100*((PR(END)/PR(START))^(1./PERIOD)-1.)
COMPUTE EMPCH = 100*((EMPRATE(END)/EMPRATE(START))^(1./PERIOD)-1.)
COMPUTE AVHRSCH = 100*((AVHRS(END)/AVHRS(START))^(1./PERIOD)-1.)
COMPUTE PRODCH = 100*((PRODUCtivity(END)/PRODUCtivity(START))^(1./PERIOD)-1.)
COMPUTE GDPCH = 100*((Y(END)/Y(START))^(1./PERIOD)-1.)
COMPUTE CHECK = PRCH+EMPCH+PRODCH+AVHRSCH
DISP '2029-30 TO 2039-40' PRCH EMPCH AVHRSCH  PRODCH GDPCH CHECK
DISP ' ______________________________________________________________'
COMPUTE START = 2040:1
COMPUTE END = 2050:1
COMPUTE PERIOD = END-START
COMPUTE PRCH = 100*((PR(END)/PR(START))^(1./PERIOD)-1.)
COMPUTE EMPCH = 100*((EMPRATE(END)/EMPRATE(START))^(1./PERIOD)-1.)
COMPUTE AVHRSCH = 100*((AVHRS(END)/AVHRS(START))^(1./PERIOD)-1.)
COMPUTE PRODCH = 100*((PRODUCtivity(END)/PRODUCtivity(START))^(1./PERIOD)-1.)
COMPUTE GDPCH = 100*((Y(END)/Y(START))^(1./PERIOD)-1.)
COMPUTE CHECK = PRCH+EMPCH+PRODCH+AVHRSCH
DISP '2039-40 TO 2049-50' PRCH EMPCH AVHRSCH  PRODCH GDPCH CHECK
DISP ' ______________________________________________________________'
COMPUTE START = 2050:1
COMPUTE END = 2060:1
COMPUTE PERIOD = END-START
COMPUTE PRCH = 100*((PR(END)/PR(START))^(1./PERIOD)-1.)
COMPUTE EMPCH = 100*((EMPRATE(END)/EMPRATE(START))^(1./PERIOD)-1.)
COMPUTE AVHRSCH = 100*((AVHRS(END)/AVHRS(START))^(1./PERIOD)-1.)
COMPUTE PRODCH = 100*((PRODUCtivity(END)/PRODUCtivity(START))^(1./PERIOD)-1.)
COMPUTE GDPCH = 100*((Y(END)/Y(START))^(1./PERIOD)-1.)
COMPUTE CHECK = PRCH+EMPCH+PRODCH+AVHRSCH
DISP '2049-50 TO 2059-60' PRCH EMPCH AVHRSCH  PRODCH GDPCH CHECK

DISP 'RATIO OF EMPLOYMENT POP RATIO 2059-60 TO 2011-12 = ' ERATE(2060:1)/ERATE(2013:1)
DISP 'RATIO OF PARTIC RATE 2059-60 TO 2011-12 =  ' PR(2060:1)/PR(2013:1)
DISP 'RATIO OF ADULT SHARE 2059-60 TO 2011-12 = ' POTENTIALWK(2060:1)/POTENTIALWK(2013:1)
DISP 'RATIO OF AV WEEKLY HOURS PER EMPLOYEE 2059-60 TO 2011-12 = ' AVHRS(2060:1)/AVHRS(2013:1)
DISP 'RATIO OF PRODUCTIVITY LEVEL PER HOUR 2059-60 TO 2011-12 = ' PROD(2060:1)/PROD(2013:1)
DISP 'RATIO OF GDP PER CAPITA 2059-60 TO 2011-12 = ' Y(2060:1)/Y(2013:1)

disp @1 '% growth in GDP from 2011-12 to 2059-60'  @120 *.## (gdp(2060:1)/gdp(2013:1)-1.)*100.
disp @1 '% growth in population from 2011-12 to 2059-60'  @120 *.## (mpop(2060:1)/mpop(2013:1)-1.)*100.
disp @1 '% growth in per capita GDP from 2011-12 to 2059-60'  @120 *.## (y(2060:1)/y(2013:1)-1.)*100.




***************************************************************************
*                                                                         *
*                  [2] GDP IF NO AGEING HAD OCCURRED                      *
*                                                                         *
***************************************************************************

SET XHRS = 0.0
SET XEMP = 0.0
SET XCPOP = CPOP(2013:1)/MPOP(2013:1)*MPOP
SET XLF = 0.0
SET XPTEMP = 0.0
SET XFTEMP = 0.0
DOFOR AGE =  '1519' '2024' '2529' '3034' '3539' '4044' '4549' '5054' '5559' '6064' '6569' '70'
  DOFOR SEX = 'M' 'F'
     	SET %S('XCPOP'+SEX+AGE) = %S('FCPOP_RATIO'+SEX+AGE)*(%S('FMAPOP'+SEX+AGE)(2013:1))/POPM(2013:1)*POPM/1000000.
      SET %S('XLF'+SEX+AGE) = %S('FPR'+SEX+AGE)*%S('XCPOP'+SEX+AGE)
      SET XLF = XLF+%S('XLF'+SEX+AGE)
      SET %S('XEMP'+SEX+AGE) = %S('FEMPRATE'+SEX+AGE)*%S('XLF'+SEX+AGE)
      SET XEMP = XEMP+%S('XEMP'+SEX+AGE)
      SET %S('XPTEMP'+SEX+AGE) = %S('FPTSH'+SEX+AGE)*%S('XEMP'+SEX+AGE)
      SET XPTEMP = %S('XPTEMP'+SEX+AGE)+XPTEMP
      SET %S('XFTEMP'+SEX+AGE) = %S('XEMP'+SEX+AGE)-%S('XPTEMP'+SEX+AGE)
      SET %S('XHRS'+SEX+AGE) = %S('FAVHRSPT'+SEX+AGE)*%S('XPTEMP'+SEX+AGE)*52.0+%S('FAVHRSFT'+SEX+AGE)*%S('XFTEMP'+SEX+AGE)*52.0
      SET XHRS = XHRS+%S('XHRS'+SEX+AGE)
  END DOFOR SEX
END DOFOR AGE
SET XPR = XLF/XCPOP*100.


SET HRSCAP_SIM = xhrs/MPOP
SET GDP_SIM = xhrs*PRODUCTIVITY

graph 2
# GDP_SIM 2013:1 2060:1
# GDP 2013:1 2060:1

COMPUTE [INTEGER] END = 2060:1
compute [REAL] output_SIM=0.0
COMPUTE [REAL] OUTPUT_b=0.0

do t = 2013:1,2060:1
   compute output_SIM=output_SIM+GDP_SIM(t)/1000.          ;*GDP in $billion received over the period from 2012-13 to 2059-60 with no ageing
   compute OUTPUT_B=OUTPUT_B+GDP(t)/1000.
end do t

DISP 'EFFECTS OF AGEING ON GDP GROWTH'
DISP '__________________________________________________________________________________'
DISP ' GDP PER CAPITA IN 2059-60 WITHOUT AGEING IS $: '  gdp_SIM(2060:1)/mpop(2060:1)
DISP ' GDP PER CAPITA IN 2059-60 WITH AGEING IS $: '  GDP(2060:1)/MPOP(2060:1)
DISP ' AGEING EFFECT IN 2059-60 IS ' GDP(2060:1)/MPOP(2060:1)-gdp_SIM(2060:1)/mpop(2060:1)
DISP 'TOTAL INCOME WITH NO AGEING FROM 2011-12 TO 2059-60 IS (IN $BILLION 2011-12 PRICES)  ' OUTPUT_SIM
DISP 'TOTAL INCOME LOST FROM AGEING FROM 2011-12 TO 2059-60 IS (IN $BILLION 2011-12 PRICES)  '  OUTPUT_SIM-OUTPUT_B
DISP 'AGEING INCOME LOST PER CAPITA FROM 2011-12 TO 2059-60 - USING AVERAGE POP IS ' (OUTPUT_SIM-OUTPUT_B)/MEANPOP

DISP '-----------------------------------------------------------------------------------'









